// wrapped by build app
define("dojoe/common/toolbar/_Toolbar", ["dijit","dojo","dojox","dojo/require!dijit/_WidgetBase,dijit/_TemplatedMixin"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("dojoe.common.toolbar._Toolbar");

dojo.require("dijit._WidgetBase");
dojo.require("dijit._TemplatedMixin");

dojo.declare("dojoe.common.toolbar._Toolbar", [ dijit._WidgetBase, dijit._TemplatedMixin], {	

	templateString:dojo.cache("dojoe.common.toolbar", "templates/Toolbar.html", "<div  dojoAttachEvent='oncontextmenu:_stopEvent' class=\"tivTable dijitToolbar\" width=\"100%\">\r\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\" role=\"presentation\">\r\n\t<tbody>\r\n\t\t<tr valign=\"center\">\r\n\t\t\t<td height=\"100%\">\r\n\t\t\t\t<span dojoAttachPoint=\"toolbarFirstRow\">\r\n\t\t\t\t\t<span dojoAttachPoint=\"stateIconNode\"></span>\r\n\t\t\t\t\t<span dojoAttachPoint=\"userDefinedNode\"></span>\r\n\t\t\t\t\t<span dojoAttachPoint=\"customIconNode\"></span>\r\n\t\t\t\t</span>\r\n\t\t\t</td>\r\n\t\t\t<td height=\"100%\">\r\n\t\t\t\t<div dojoAttachPoint=\"quickFilterNode\" role=\"search\">\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t\t<td>\r\n\t\t\t\t<div dojoAttachPoint=\"filterButton\" role=\"button\">\r\n\t\t\t\t</div>\r\n\t\t\t</td>\t\t\t\r\n\t\t</tr>\r\n\t\t<tr valign=\"center\">\r\n\t\t\t<td width=\"100%\">\r\n\t\t\t\t<span dojoAttachPoint=\"toolbarSecondRow\">\r\n\t\t\t\t</span>\t\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t</tbody>\t\t\r\n</table>\r\n</div>"),
	widgetsInTemplate:true,
			
	// To add the item/icon to the toolbar.
	
	_addStateControl: function(item, position) {
		if (item != null) {
			var spanNode = dojo.doc.createElement("span", {role : "button"}); 
			dojo.style(spanNode, "width", "1px"); 
			if(position !== undefined){
				dojo.place(spanNode, this.stateIconNode, parseInt(position));
			}else {
				dojo.place(spanNode, this.stateIconNode, 'last');
			}
			spanNode.appendChild(item.domNode);
		}
	},
	
	_addFastPathControl: function(item, position) {
		if (item != null) {
			var spanNode = dojo.doc.createElement("span", {role : "button"}); 
			dojo.style(spanNode, "width", "1px"); 
			if(position !== undefined){
				dojo.place(spanNode, this.customIconNode, parseInt(position));
			}else {
				dojo.place(spanNode, this.customIconNode, 'last');
			}
			spanNode.appendChild(item.domNode);
		}
	},
	
	//do not call this method directly, use table._addCustomControl(item, position, row) method to add a custom item to the toolbar before default buttons
	_addCustomControl: function(item, position, row){
		if (item != null) {
			var spanNode = dojo.doc.createElement("span", {role : "button"}); 
			dojo.style(spanNode, "width", "1px"); 
			if(row == 2) {
				if(position !== undefined){
					dojo.place(spanNode, this.toolbarSecondRow, parseInt(position));
				}else {
					dojo.place(spanNode, this.toolbarSecondRow, 'last');
				}
				spanNode.appendChild(item.domNode);
			} else {
				if(position !== undefined){
					dojo.place(spanNode, this.userDefinedNode, parseInt(position));
				}else {
					dojo.place(spanNode, this.userDefinedNode, 'last');
				}
				spanNode.appendChild(item.domNode);
			} 
		}
	}		
	
});
});
