require({cache:{
'url:dojoe/list/templates/List.html':"<div class=\"twllist\" style=\"height:100%;width:100%\">\n\t<div data-dojo-type=\"dijit/layout/ContentPane\" data-dojo-attach-point=\"searchPane\" class=\"qFilterBar\">\n\t\t<table width=100% role=\"presentation\">\n\t\t\t<tr>\n\t\t\t<td width=100%>\n\t\t\t\t<input data-dojo-attach-point=\"searchField\" title=\"${nls.SEARCH}\" class=\"dijitInputInner qf-textfield\" type=\"text\" \n\t\t\t\t\tvalue=\"${nls.SEARCH}\" valign=\"middle\" tabindex=\"0\" role=\"textbox\" style=\"height:30px;\" placeholder=\"${nls.SEARCH}\"\n\t\t\t\t\tdojoAttachEvent='onfocus:_onFocus,onkeyup:_onKeyUp'/>\t\n\t\t\t</td>\n\t\t\t<td>\n\t\t\t\t<button title=\"${nls.CLEAR}\" class=\"dijitReset dijitInline dijitIcon quickFilterClearInner\" type=\"button\" tabindex=\"0\" \n\t\t\t\t\tvalign=\"middle\" data-dojo-attach-point='clearFilterNode' role=\"button\"></button>\t\t\n\t\t\t</td>\n\t\t\t<td>\t\t\t\n\t\t\t\t<button data-dojo-type=\"dijit/form/Button\" label=\"${nls.SEARCH}\" \n\t\t\t\t\tdata-dojo-props=\"iconClass:'searchButton', showLabel: false\",\n\t\t\t\t\ttype=\"button\" tabindex=\"0\" \n\t\t\t\t\tvalign=\"middle\" data-dojo-attach-point='searchButtonNode' role=\"button\"></button>\t\t\t\n\t\t\t</td>\n\t\t\t</tr>\n\t\t</table>\n\t</div>\n\t<div data-dojo-type=\"dojox/mobile/ContentPane\" data-dojo-attach-point=\"listWidgetContainer\" class=\"listWidget\">\n\t\t<div data-dojo-attach-point=\"scrollableContainer\" style=\"height:100%;width:100%\">\n\t\t\t<div id=\"${id}_listWidget\" data-dojo-attach-point=\"listWidgetDiv\" style=\"height:100%;width:100%\">\n\t\t\t\t<div class=\"loading\" id=\"${id}listWidgetMsg\">${nls.LOADING}</div>\n\t\t\t</div>\n\t\t</div>\t\t\t\n\t</div>\t\n\t<div id=\"${id}_filterBar\" class=\"filterBar\" data-dojo-attach-point=\"filterBarContainer\" dir=\"${dir}\">\n\t\t<ul data-dojo-attach-point=\"filterBarDiv\"></ul>\n\t</div>\n</div>\n",
'url:dojoe/list/templates/emptyTemplate.html':"<div class=\"row first last\" align=\"center\">\n  <!-- <b>${nls.DATA_ERROR}</b> -->\n  <div class=\"noData\" title=\"No data found\"></div>\n</div>\n",
'url:dojoe/list/templates/rowTemplate.html':"<div class=\"row\" dojoType=\"dojox.mobile.ListItem\">\n  <table style=\"table-layout:fixed;white-space:nowrap;\" role=\"presentation\">\n    <tr>\n      <td class=\"${SevStyle}\">\n          <!--<span class=\"listBtn noclick ${Severity}Item\"></span>-->\n\t\t  <img src=\"${Image}\" alt=\"${Tooltip}\" title=\"${Tooltip}\" width=\"32\" height=\"32\" />\n      </td>\n      <td width='100%'>\n      \t<table style=\"table-layout:fixed;white-space:nowrap;width:100%;\" role=\"presentation\"><tr>\n\t\t  <td style=\"direction:${TextDir1};text-align:${TextAlign}\">${Node}</td> \n\t\t </tr><tr>\n\t\t  <td style=\"font-size:90%;color:grey;direction:${TextDir2};text-align:${TextAlign}\" title=\"${Summary}\">${Summary}</td>\n\t\t  </tr></table>\t\n\t  </td>\n\t  <td valign='bottom' style=\"font-size:90%;color:grey;direction:ltr;text-align:${TextAlign}\">${LastOccurrenceTime}</td> \n      <!--<td align='right'>\n          <img src=\"../images/Arrow.png\"/>\n      </td>-->   \n    </tr>\n  </table>\n</div>\n",
'url:dojoe/list/templates/dividerTemplate.html':"<div class=\"divider\">\n\t<span style=\"display:inline-block;direction:ltr;\">${label}</span>\n</div>\n"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/list/List", [
	"dojo/_base/declare",
	"dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
	"dijit/_WidgetsInTemplateMixin",
	"dojoe/list/_List",
	"dojo/i18n!./nls/List",
	"dojo/dom-style",
	"dojo/dom-class",
	"dojoe/BidiUtil",
	"dojo/text!./templates/List.html",
	"dojo/has",
	"dojox/mobile/ScrollablePane",
	"dojo/query",
	"dojox/mobile/sniff",
	"dojoe/Util",
	"dojox/mobile/ContentPane",
	"dijit/layout/ContentPane",
	"dojox/mobile/compat",
	"dijit/form/Button",
	"dojo/text!./templates/emptyTemplate.html",
	"dojo/text!./templates/rowTemplate.html",
	"dojo/text!./templates/dividerTemplate.html",
	"dojox/mobile/ListItem"	
], function(declare, _WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin,  
		List, nlsBundle, domStyle, domClass, bidiUtil, template, has, ScrollablePane, query) {
	return declare("dojoe.list.List", [_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin], {
		configInfo: null,
		templateString: template,
		severityMapping: null,
		dataset: null,
		listWidget: null,
		nls: nlsBundle,
		_start : 0,
		_count : 0,
		_pageSize: 50,
		filterBar:null,
		_paginationRow: null,
		enableFilter: true,
		enableSearch: true,
		
		// List
		// Summary:
		// 		Creates an Event List viewer with filter bar.
		// 		The constructor accepts the following properties:
		// 			sort: Comma separated property Ids to sort. 
		// 			datasetInfo:
		// 				Object that contains:
		// 					baseUrl: CURI base url. Optional. Default: /ibm/tivoli/rest
		// 					provider: CURI provider ID. Default: OMNIbusWebGUI
		// 					datasource: CURI datasource ID. Default: ""
		// 					dataset: CURI dataset ID. Default: eventData
		// 					parameters: An object that contains the dataset parameters.
		// 							Example: { filter: "Severity = 5" }.
		// 						Default:  {
		//							filter : this.currentFilter, 
		//							view: 'Default:global', 
		//							datasources: 'NCOMS'}
		// 					defaultProperties: An array of properties to return this dataset. Default: ["all"]
		postCreate: function() {
			this.inherited(arguments);			
			
			if(this.configInfo.pageSize) this._pageSize = this.configInfo.pageSize;	
			this._rowData = new Array();			
			if (!this.severityMapping) {
				// set defaults severity mapping.
				this.severityMapping = {
					'7' : 'Indeterminate',
					'6' : 'Normal',
					'5' : 'Unknown',
					'4' : 'MajorWarn',
					'3' : 'Info',
					'2' : 'Undefined',
					'1' : 'MinorWarn',
					'0' : 'Critical',
					'-1' : 'Fatal'
				};
			}
			
			if (!this.severityImageMapping) {
				// set defaults severity mapping.
				this.severityImageMapping = {
					'Normal' : require.toUrl("dojoe/list/images/Normal.png"),
					'Critical' : require.toUrl("dojoe/list/images/Critical.png"),
					'Fatal' : require.toUrl("dojoe/list/images/Fatal.png"),
					'Info' : require.toUrl("dojoe/list/images/Informational.png"),
					'MajorWarn' : require.toUrl("dojoe/list/images/MajorWarning.png"),
					'MinorWarn' : require.toUrl("dojoe/list/images/MinorWarning.png"),
					'Unknown' : require.toUrl("dojoe/list/images/Unknown.png"),
					'Undefined' : require.toUrl("dojoe/list/images/Undefined.png"),
					'Indeterminate' : require.toUrl("dojoe/list/images/Indeterminate.png"),
				};
			}	

			if (!this.severityNlsMapping) {
				// set defaults severity mapping.
				this.severityNlsMapping = {
					'Normal' : this.nls.NORMAL,
					'Critical' : this.nls.CRITICAL,
					'Fatal' : this.nls.FATAL,
					'Info' : this.nls.INFO,
					'MajorWarn' : this.nls.MAJOR_WARNING,
					'MinorWarn' : this.nls.MINOR_WARNING
				};
			}	

			if(has("iphone") || has("bb") || has("android") || has("touch")){
				ScrollablePane({},this.scrollableContainer);
			} 			
		
			// create list widget		
			this.listWidget = List({
				"class":"iconList",
				//Bobby: 12Oct2012, row disappeared on drag/hold
				autoDelete:false,
				enableDelete: false,
				enableHold: true,
				itemTemplate: require.toUrl("dojoe/list/templates/rowTemplate.html"),
				dividerTemplate: require.toUrl("dojoe/list/templates/dividerTemplate.html"),
				emptyTemplate: require.toUrl("dojoe/list/templates/emptyTemplate.html"),
				noDataMessage: this.nls.DATA_ERROR
			},this.listWidgetDiv);
			
			this.listWidget.set("items", {});				
			console.info("List.js: after List creation...");	
					
			if(!this.configInfo.Severity || 
				this.configInfo.Severity=="None" || 
				this.configInfo.Severity=="" || 
				this.configInfo.Severity=="undefined"){
					this.hideFilterBar();
			}
			
			console.info("this.enableFilter:"+this.enableFilter);
			console.info("this.enableSearch:"+this.enableSearch);
			
			//this.pagingButtonNode.src = require.toUrl("dojoe/list/images/next.png");
			//this.refreshButtonNode.src = require.toUrl("dojoe/list/images/refresh.png");
			//if(this.searchButtonNode) this.searchButtonNode.src = require.toUrl("dojoe/list/images/search.png");
			//else console.warn('List.js: postCreate(): this.searchButtonNode not found!');	
			//if(this.clearButtonNode) this.clearButtonNode.src = require.toUrl("dojoe/list/images/clear.png");
			//this.pagingButtonNode.onclick = lang.hitch(this,this._retrieveMoreItems);	
			
			//console.info("listWidget.postCreate(): thresholds before sorting:");
			//console.dir(this.configInfo.thresholds);
			
			//sort the thresholds by value
			this.configInfo.thresholds.configured = false;
			/*this.configInfo.thresholds.sort(function(a, b){
				if (parseInt(a.value) < parseInt(b.value)) //sort string ascending
					return -1; 
				if (parseInt(a.value) > parseInt(b.value))
					return 1;
				return 0; //default return value (no sorting)
			});	

			this.configInfo.thresholds.configured = false;
			for(var i=0;i<this.configInfo.thresholds.length;i++){
				if(this.configInfo.thresholds[i].value) this.configInfo.thresholds.configured = true;
				break;					
			}*/			
			
			console.info("listWidget.postCreate(): thresholds configured:"+this.configInfo.thresholds.configured);
			
			//console.info("listWidget.postCreate(): thresholds after sorting:");
			//console.dir(this.configInfo.thresholds);			
			
			console.info("listWidget.postCreate()........ END");
		},
		
		_onFocus : function() {
			dojo.addClass(this.searchField, 'dijitTextBoxFocused');
			if (this.searchField.value == this.nls.SEARCH) {
				this.searchField.value = "";
			}
		},		
		
		hideFilterBar: function() {
			console.log("List.js: hideFilterBar()......");
			//this.filterBarDiv.domNode.style="display:none";
			//Bobby: 20Nov2012, setting z-index to -1 for hidden div
			//57915:  Occasionally: Last row of List Widget does not send an event
			//if(this.filterBarContainer) domStyle.set(this.filterBarContainer,"display","none");
			if(this.filterBarContainer) domStyle.set(this.filterBarContainer,{"display":"none","z-index":-1});
			//60809: TWL 1.1 : List display is disturbed (list items overlap Quick filter bar and Quick filter icons) when drag and drop another List Dashlet
			//Bobby: 13Dec2012, this will affect all list widgets on page!
			//query(".twllist .listWidget").style("bottom", '0');	
			if(this.listWidgetContainer) domStyle.set(this.listWidgetContainer.domNode,{"bottom":"0"});			
			domClass.add(this.listWidgetDiv, "noSev");	
			if(this.filterBar) this.filterBar.destroyRecursive();
			this.filterBar = null;
			//this.listContainer.resize();
		},	

		hideSearchBar: function() {
			console.log("List.js: hideSearchBar()......");
			//Bobby: 20Nov2012, setting z-index to -1 for hidden div
			//57915:  Occasionally: Last row of List Widget does not send an event
			//if(this.searchPane) domStyle.set(this.searchPane,"display","none");
			if(this.searchPane) domStyle.set(this.searchPane,{"display":"none","z-index":-1});
			//60809: TWL 1.1 : List display is disturbed (list items overlap Quick filter bar and Quick filter icons) when drag and drop another List Dashlet
			//Bobby: 13Dec2012, this will affect all list widgets on page!			
			//query(".twllist .listWidget").style("top", '0');	
			if(this.listWidgetContainer) domStyle.set(this.listWidgetContainer.domNode,{"top":"0"});		
			if(this.searchPane) this.searchPane.destroyRecursive();
			this.searchPane = null;
			//this.listContainer.resize();
		},			
		
		//46512: List - filter bar layout is broken and one filter icon is missing when reopening page
		//Bobby: 18Jul2012 - using TIP Portlet resize event to fix the layout after portlet is rendered
		resize: function(size) {
			console.info('listWidget.resize()..... BEGIN');
			console.dir(size);
			try{
				if(this.filterBar && this.filterBar.resize) this.filterBar.resize();
			}catch(err){
				console.warn(err);
			}	
			console.info('listWidget.resize()..... END');
		},
		
				
		startup: function() {
			console.info("List.startup()........ BEGIN");	

			if(!this.enableFilter) this.hideFilterBar();
			if(!this.enableSearch) this.hideSearchBar();			
			
			// startup widgets
			if(this.listWidget){
				console.info("listWidget.startup() - BEGIN");
				if(this.listWidget.startup) this.listWidget.startup();
				console.info("listWidget.startup() - DONE");
				//this.filterEventList(null, null);
				//console.info("filterEventList()- DONE");
			}	
			try{
				this.inherited(arguments);	
			}catch(err){
				console.debug(err);
			}	
			console.info("List.startup()........ END");										
		},						
				
		processData: function(items, errorMessage){				
			//console.dir(items);					
			if(items){	
				console.info("items.length:"+items.length);
				console.debug("this.rowdata length ...."+this._rowData.length);
				//this.listWidget.set("items", {});
				
				if(this._rowData.length > 0) {
					var len = this._rowData.length;
					var lastItem = this._rowData[len-1];
					console.debug("last item ...");
					console.debug(lastItem);
					 if(lastItem.Identifier == "moreItems") {
						this._rowData = this._rowData.slice(0,len-1);
					 }
				}
				
				var noColumnMapped = 
					(this.configInfo.Identifier == "None" || this.configInfo.Identifier == "undefined")&&
					(this.configInfo.Severity == "None" || this.configInfo.Severity == "undefined")&& 
					(this.configInfo.Node == "None" || this.configInfo.Node == "undefined")&& 
					(this.configInfo.Summary == "None" || this.configInfo.Summary == "undefined")&& 
					(this.configInfo.LastOccurrenceDate == "None" || this.configInfo.LastOccurrenceDate == "undefined"); 
				
				if(this.configInfo && !noColumnMapped){
					/* Data globally accessible so eventDetails view can access data */
					this.eventListRawData = items;
				
					//var rowData = new Array();
					var sev, lastOccTime, lastOccDate, tempDate,lastOccDate_Display, tempTimestamp;
					var textAlign = this.dir == "ltr"? "left" : "right";
					var nodeVal, summaryVal = "";
					var textDir1, textDir2;	
					var tooltip, image, sevLabel,sevStyle;		
					
					for (var i=0;i<items.length;i++){
						if(this.configInfo.Severity != "None"){
							if(items[i].getProperty(this.configInfo.Severity)){
								//Bobby: 17Jul2012, adding support for Status Object
								//sev = this.severityMapping[items[i].getProperty(this.configInfo.Severity).getValue()];
								var statusObj = items[i].getProperty(this.configInfo.Severity).getValue();
								// Need work here
								if (statusObj.getValue && !this.configInfo.thresholds.configured) {
									sev = statusObj.getValue();
									//console.dir(statusObj);
									tooltip = statusObj.getTooltip();	
									image = statusObj.getImage();	
									if(image.indexOf('[widget]') > -1){
										//Bobby: 04Oct2012, pointing to 32x32 version of the 16x16 icons
										//image = image.replace('[widget]', "ibm/tivoli/tip/navwidget/themes");
										image = image.replace('[widget]', "dojoe/list/themes");
										image = require.toUrl(image);
									}else{
										//TIP issue? Ideally should have a valid session on remote server
										//Bobby:09Aug2012, temp fix since can't access image from remote server
										//image = require.toUrl("dojoe/list/images/"+sev+".png");	
									}	
									//console.log('image:'+image);	
									sevLabel = statusObj.getLabel();
								} else if(this.configInfo.thresholds.configured){
									if (statusObj.getValue) sev = statusObj.getValue();								
									else sev = statusObj;								
									for(var j=0;j<this.configInfo.thresholds.length;j++){
										if(sev >= this.configInfo.thresholds[j].value){
											image = this.severityImageMapping[this.configInfo.thresholds[j].type];
											tooltip = this.severityNlsMapping[this.configInfo.thresholds[j].type];								
										}	
									}		
									sevLabel = sev;									
								}else{
									sev = statusObj;
									var sevName;
									if(sev > -2 && sev < 8){ //0-6								
										sevName = this.severityMapping[sev];
									}else{ 
										sevName = this.severityMapping[5];//Unknown
									}		
									image = this.severityImageMapping[sevName];		
									sevLabel = statusObj;								
									tooltip = this.severityMapping[statusObj];
								}
							}	
						}
						//53631: TWL 1.1 : missing icons in list dashlet on IE8
						//Bobby: 18Oct2012, Adding a default image as some browsers like IE and Chrome needs some image
						if(!image){
							//image = require.toUrl("dojoe/list/images/blank.png");
							//tooltip = this.nls.UNKNOWN;
							sevStyle = "noImage";	
						}else sevStyle = "";	
						
						/*if(sev == null) {
							sev = 'clear';
						}*/
						//tempDate = new Date();
						//tempDate = new Date(items[i].getProperty("LastOccurrence").getValue());
						/*lastOccTime = tempDate.getHours() + ":" + 
						(tempDate.getMinutes()<10? "0"+tempDate.getMinutes():tempDate.getMinutes());*/						
						
						try{	
							if(this.configInfo.LastOccurrenceDate != "None"){						
								if(items[i].getProperty(this.configInfo.LastOccurrenceDate)){
									tempTimestamp = items[i].getProperty(this.configInfo.LastOccurrenceDate).getValue(); 
									//console.info("Timestamp:"+tempTimestamp);
									if(typeof tempTimestamp == 'number'){
										tempDate = parseInt(tempTimestamp) *1000;
									}else tempDate = tempTimestamp;	
									//tempDate = items[i].getProperty(this.configInfo.LastOccurrenceDate).getDisplayValue();
									//console.info("tempDate:"+tempDate);
									lastOccTime = this.dateFormat(tempDate, "shortTime");	
									lastOccDate = this.dateFormat(tempDate, "mediumDate");		
									lastOccDate_Display = items[i].getProperty(this.configInfo.LastOccurrenceDate).getDisplayValue();
								}	
							}
							if(this.configInfo.Node != "None"){
								//61660: [BigDecimal]TWL 1.1 : BIG Decimal / Double values cannot be filtered on List dashlet
								//Bobby: 01Jan2013, contains filter works only with displayValue
								//nodeVal = items[i].getProperty(this.configInfo.Node)? items[i].getProperty(this.configInfo.Node).getValue(): null;
								nodeVal = items[i].getProperty(this.configInfo.Node)? items[i].getProperty(this.configInfo.Node).getDisplayValue(): null;
							}	
							if(this.configInfo.Summary != "None"){
								//61660: [BigDecimal]TWL 1.1 : BIG Decimal / Double values cannot be filtered on List dashlet
								//Bobby: 01Jan2013, contains filter works only with displayValue
								//summaryVal = items[i].getProperty(this.configInfo.Summary)? items[i].getProperty(this.configInfo.Summary).getValue(): null;								
								summaryVal = items[i].getProperty(this.configInfo.Summary)? items[i].getProperty(this.configInfo.Summary).getDisplayValue(): null;
							}	
							textDir1 = bidiUtil.getResolvedDir(nodeVal,this.textDir,this.dir);
							textDir2 = bidiUtil.getResolvedDir(summaryVal,this.textDir,this.dir);
							
							this._rowData.push({
								'Severity': sevLabel,
								'Node': escapeHTML(nodeVal),
								'Identifier': items[i].getId(),
								'Summary': escapeHTML(summaryVal),
								'LastOccurrenceTime': lastOccTime,
								'LastOccurrenceDate': lastOccDate_Display,
								'LastOccurrenceDate_internal': lastOccDate,
								'TextDir1': textDir1,
								'TextDir2': textDir2,
								'TextAlign': textAlign,
								'Tooltip': tooltip,
								'Image': image,
								'SevStyle': sevStyle
							});
						}catch(err){
							console.debug(err);
						}
					}						
		
					if(this.listWidget){
						/*listWidget.dividerFunction = function(item){
							return item.label < "Row 5" ? "Today" : "Yesterday";
						};*/
						var today = this.dateFormat(new Date(), "mediumDate");
						//Date has issues in Breeze!
						//var yesterday = this.dateFormat(Date.parse('yesterday'), "mediumDate");
						var myDate=new Date();
						myDate.setDate(myDate.getDate()-1);						
						var yesterday = this.dateFormat(myDate, "mediumDate");
					
						//console.info(today);
						//console.info(yesterday);
					
						//console.info(Date.today());
						//console.info(Date.parse('tomorrow'));
						//console.info(Date.parse('yesterday'));
					
					
						this.listWidget.configInfo = this.configInfo;	
						this.listWidget.dividerFunction = function(item){
							//console.log(item.LastOccurrenceDate);
							/*return ((item.LastOccurrenceDate.getMonth()+1)+"-"
							+item.LastOccurrenceDate.getDate()+"-"
							+item.LastOccurrenceDate.getFullYear());*/
							if(this.configInfo.groupBy && this.configInfo.groupBy!='None'){
								if(this.configInfo.groupBy == 'Date'){
									if (item.LastOccurrenceDate_internal == today) return "Today";
									else if (item.LastOccurrenceDate_internal == yesterday) return "Yesterday";
									else return item.LastOccurrenceDate_internal;
								}else if(this.configInfo.groupBy == 'Status'){
									return item.Severity;
								}else if(this.configInfo.groupBy == 'Label'){
									return item.Node;
								}								
							}else{
								if (item.LastOccurrenceDate_internal == today) return "Today";
								else if (item.LastOccurrenceDate_internal == yesterday) return "Yesterday";
								else return item.LastOccurrenceDate_internal;							
							}							
						};
						if(this._paginationRow == null) {
								this._paginationRow = {
									'Identifier': "moreItems",
									'Node': this.nls.SHOW_MORE,
									'TextAlign' : textAlign,
									'Image': require.toUrl("dojoe/list/images/next.png"),
									'Tooltip': this.nls.SHOW_MORE									
								};
							}
							console.debug("this._count : "+this._count);
							console.debug("this.dataset.getItemCount(): "+this.dataset.getItemCount());
						//Latha: 55495: TWL 1.1 : Show more items in List dashlet is shown even when there are no more filter items to be shown
						if((this._count < this.dataset.getItemCount() && items.length >= this._pageSize)) {
							 this._rowData.push(this._paginationRow);
						}
					//	console.info('this._rowData:');
					//	console.dir(this._rowData);
						console.info('this._rowData length:'+this._rowData.length);
						this.listWidget.set("items", this._rowData);
					}
				}else{
					console.warn("this.configInfo.Identifier:"+this.configInfo.Identifier);
					if(dojo.byId(this.id+"listWidgetMsg")) dojo.byId(this.id+"listWidgetMsg").innerHTML = this.nls.ATTRIBUTE_MAPPING_ERROR;
				}	
				console.debug("listWidget.get('items').length..."+this.listWidget.get("items").length);
				//this.displayCount.innerHTML = this.listWidget.get("items").length + "/" + this.dataset.getItemCount();			
			}else{
				//console.dir(this.domNode);
				//dojo.byId(this.domNode.innerHTML = "No data found!");
				//if(this.listWidget) this.listWidget.destroy();
				//if(dojo.byId(this.id+"listWidgetMsg")) dojo.byId(this.id+"listWidgetMsg").innerHTML = this.nls.DATA_ERROR;
				if(this.listWidget){
					//console.info("errorMessage:"+errorMessage);
					this.listWidget.set("items", [{
						'Identifier': "errorMessage",
						'Node': this.nls.DATA_ERROR,
						'Summary': errorMessage,
						'TextAlign' : textAlign,
						'Image': require.toUrl("dojoe/list/images/Critical.png"),
						'Tooltip': this.nls.CRITICAL						
					}]);
				}
			}				
		},
		
		destroy: function() {
			console.info("List.js: destroy BEGIN...");
			console.debug("List.js: id:"+this.id);
			this.destroyWidgets();
			if(dojo.byId(this.id+"_ListDiv")) dojo.forEach(dijit.findWidgets(dojo.byId(this.id+"_ListDiv")), function(widget){
				// Avoid double destroy of widgets like Menu that are attached to body
				// even though they are logically children of other widgets.
				if(widget && !widget._destroyed){
					if(widget.destroyRecursive){
						widget.destroyRecursive();
					}else if(widget.destroy){
						widget.destroy();
					}
				}
			});	
			this.inherited(arguments);					
			console.info("List.js: destroy END...");
		},
		
		destroyWidgets: function() {
			try{
				if(this.listWidgetDiv){
					var listWidget = dojo.byId(this.listWidgetDiv);
					if(listWidget.destroyRecursive) listWidget.destroyRecursive();
					else if(listWidget.destroy) listWidget.destroy();
				}	
				if(this.filterBarDiv){
					var filterBar = dojo.byId(this.filterBarDiv);
					if(this.filterBar){
						if(this.filterBar.destroyRecursive) this.filterBar.destroyRecursive();
						else if(this.filterBar.destroy) this.filterBar.destroy();
					}	
				}				
				if(this.dataset && this.dataset.destroy) this.dataset.destroy();
			} catch (ex) {
				console.error ("List.js: Caught exception in destroy:");
				console.error (ex);
			}
		},

		 /* 
		 * Accepts a date, a mask, or a date and a mask.
		 * Returns a formatted version of the given date.
		 * The date defaults to the current date/time.
		 * The mask defaults to masks.default.
		 */
		dateFormat: function(date, mask, utc) {				
			var	token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,
			timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
			timezoneClip = /[^-+\dA-Z]/g;	

			var masks = {
				"default":      "ddd mmm dd yyyy HH:MM:ss",
				shortDate:      "m/d/yy",
				mediumDate:     "mmm d, yyyy",
				longDate:       "mmmm d, yyyy",
				fullDate:       "dddd, mmmm d, yyyy",
				shortTime:      "h:MM TT",
				mediumTime:     "h:MM:ss TT",
				longTime:       "h:MM:ss TT Z",
				isoDate:        "yyyy-mm-dd",
				isoTime:        "HH:MM:ss",
				isoDateTime:    "yyyy-mm-dd'T'HH:MM:ss",
				isoUtcDateTime: "UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"
			}	
			
			var i18n = {
				dayNames: [
					"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat",
					"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"
				],
				monthNames: [
					"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
					"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
				]
			}					
		
			// You can't provide utc if you skip other args (use the "UTC:" mask prefix)
			if (arguments.length == 1 && Object.prototype.toString.call(date) == "[object String]" && !/\d/.test(date)) {
				mask = date;
				date = undefined;
			}

			// Passing date through Date applies Date.parse, if necessary
			date = date ? new Date(date) : new Date;
			if (isNaN(date)) throw SyntaxError("invalid date");

			mask = String(masks[mask] || mask || masks["default"]);

			// Allow setting the utc argument via the mask
			if (mask.slice(0, 4) == "UTC:") {
				mask = mask.slice(4);
				utc = true;
			}

			var	_ = utc ? "getUTC" : "get",
				d = date[_ + "Date"](),
				D = date[_ + "Day"](),
				m = date[_ + "Month"](),
				y = date[_ + "FullYear"](),
				H = date[_ + "Hours"](),
				M = date[_ + "Minutes"](),
				s = date[_ + "Seconds"](),
				L = date[_ + "Milliseconds"](),
				o = utc ? 0 : date.getTimezoneOffset(),
				flags = {
					d:    d,
					dd:   this.pad(d),
					ddd:  i18n.dayNames[D],
					dddd: i18n.dayNames[D + 7],
					m:    m + 1,
					mm:   this.pad(m + 1),
					mmm:  i18n.monthNames[m],
					mmmm: i18n.monthNames[m + 12],
					yy:   String(y).slice(2),
					yyyy: y,
					h:    H % 12 || 12,
					hh:   this.pad(H % 12 || 12),
					H:    H,
					HH:   this.pad(H),
					M:    M,
					MM:   this.pad(M),
					s:    s,
					ss:   this.pad(s),
					l:    this.pad(L, 3),
					L:    this.pad(L > 99 ? Math.round(L / 10) : L),
					t:    H < 12 ? "a"  : "p",
					tt:   H < 12 ? "am" : "pm",
					T:    H < 12 ? "A"  : "P",
					TT:   H < 12 ? "AM" : "PM",
					Z:    utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
					o:    (o > 0 ? "-" : "+") + this.pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
					S:    ["th", "st", "nd", "rd"][d % 10 > 3 ? 0 : (d % 100 - d % 10 != 10) * d % 10]
				};

			return mask.replace(token, function ($0) {
				return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
			});
		},
		
		pad: function (val, len) {
			val = String(val);
			len = len || 2;
			while (val.length < len) val = "0" + val;
			return val;
		},

		//Events----------------------------------------------------------------------
		onSelected: function(row){
			return row;
		}		
			
	});
});
