require({cache:{
'url:dojoe/ssd/quickedit/templates/QueryDatasets.html':"<div class=\"twlssd\" style=\"height:100%;width:100%;\">\n\t<div class=\"searchArea\" >\n\t\t${nls.SEARCH_DESC}\n\t\t<br/>\n\t\t<input id=\"${id}searchfield\" \n\t\t\t\tclass=\"dijitTextBox\"\n\t\t\t\tdata-dojo-attach-point=\"searchfield\" type=\"text\" \n\t\t\t\ttitle=\"${nls.SEARCH}\"\n\t\t\t\tname=\"dff_keyword\" maxlength=\"256\" valign='bottom' height='22px'/>\n\t\t<button data-dojo-attach-point=\"searchButtonNode\" type='button'></button>\n\t\t<button data-dojo-attach-point=\"cancelButtonNode\" type='button'></button>\n\t\t<br/><br/>\n\t\t${nls.DATASET_DESC}\n\t\t<div class=\"searchResults\">\t\n\t\t\t<div id=\"${id}listWidget\" data-dojo-attach-point=\"listWidgetDiv\">\n\t\t\t\t&nbsp;<br/>&nbsp;<br/>&nbsp;<br/>&nbsp;<br/>&nbsp;<br/>\n\t\t\t\t<div align=\"center\"><b><i><button data-dojo-attach-point=\"showAllButtonNode\" type='button'></button></i></b></div>\n\t\t\t</div>\n\t\t</div>\t\n\t</div>\t\n\t<div class=\"messageArea\">\n\t\t<div class=\"countMsg\"><i>${nls.FOUND}:&nbsp;<span data-dojo-attach-point=\"datasetCountNode\"></span></i></div>\n\t\t<div data-dojo-attach-point=\"messageAreaNode\"></div>\t\n\t</div>\t\n\t<!-- Required for Cancel -->\n\t<form method=\"post\" action=\"${formURL}\" id=\"${portletId}_editForm\">\n\t</form>\t\t\n</div>\n"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/ssd/quickedit/QueryDatasets", [
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojox/mobile/View",
	"dijit/form/Button",
	"dojox/mobile/app/List",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dojo/text!./templates/QueryDatasets.html",
	"dojo/i18n!./nls/QueryDatasets",
	"dojox/widget/Standby",
	"dojoe/multimessagearea/MultiMessageArea",
	'dojo/date',
	'dijit/form/TextBox',
    "dojox/mobile/Heading",
	'dojox/mobile', //reqd for Chrome
	'dojox/mobile/compat', //reqd for FF
	'dojoe/Util'
], function (declare,lang, view, button, List, _WidgetBase, _TemplatedMixin, template, nlsBundle, Standby,MultiMessageArea) {
	 return declare("dojoe.ssd.quickedit.QueryDatasets", [_WidgetBase, _TemplatedMixin], {
		templateString: template,
		nls: nlsBundle,
		//widgetsInTemplate: true,
		widgetSearchConfig: null,
		clearSearchFlag: false,
		providers: null,
		progressBar: null,
		providerLabels: {},
		datasetLabels: {},
		messageArea: null,
		msgId:0,
		listWidget:null,
		_fetchInit:0,
		_fetchComplete:0,
		_existingItems:null,
		formURL: null,

		constructor: function (props) {
			lang.mixin (this, props);
		},

		postCreate:function () {
			//dojo.connect(this.searchbutton, "onClick", this, this._searchForDatasets);
			//var fnc = dojo.hitch (this, this._searchForDatasetsAll);
			this.searchfield.onkeypress = dojo.hitch(this, function(event){
				//55241: TBSM 3xxxx: QuickEdit: Select a Dataset: IE: enter key does not initiate Search like Firefox
				//Bobby: 23Oct2012, If event doesn't exist (like in IE), replace it with window.event
				event=event||window.event;				
				if(event.keyCode == 13 ) { //Enter
					this._searchForDatasetsAll();
					return false;
				}
			});
			this.searchbutton = new button({
				showLabel: true,
				id: this.id+"searchButton",
				//iconClass: "searchIcon",
				label: this.nls.SEARCH,
				title: this.nls.SEARCH
			}, this.searchButtonNode);
			this.showAllButton = new button({
				showLabel: true,
				id: this.id+"showAllButton",
				label: this.nls.SHOWALL,
				title: this.nls.SHOWALL
			}, this.showAllButtonNode);
			this.cancelButton = new button({
				showLabel: true,
				id: this.id+"cancelButton",
				label: this.nls.CANCEL,
				title: this.nls.CANCEL
			}, this.cancelButtonNode);			
			//this.searchbutton.onclick = fnc;
			dojo.connect(this.searchbutton, "onClick", this, this._searchForDatasetsAll);
			dojo.connect(this.showAllButton, "onClick", this, this._searchForDatasetsAll);
			dojo.connect(this.cancelButton, "onClick", quickEdit.onEditCancel);

			this.progressBar = new Standby({target: quickEdit.view1.domNode});
			this.domNode.appendChild(this.progressBar.domNode);
			this.progressBar.startup();
			var currentDate = new Date();
			var currentTime = currentDate.getTime();
			this.messageArea = new MultiMessageArea({"closable": false});			
			this.messageAreaNode.appendChild(this.messageArea.domNode);
			//this.messageArea.startup();
			this.datasetCountNode.innerHTML = 0;
		},

		_searchForDatasetsAll: function() {
		
			//reset fetch counters
			this._fetchInit = 0;
			this._fetchComplete = 0;
			
			//reset messagearea
			var currentDate = new Date();
			var currentTime = currentDate.getTime();
			if(this.messageArea) this.messageArea.destroy();
			this.messageArea = new MultiMessageArea({"closable": false});			
			this.messageAreaNode.appendChild(this.messageArea.domNode);
			this.progressBar.show();

			//42506: Datasets are loaded twice when search button is clicked twice
			//Bobby:05Jul2012, empty list if searched again
			if(this.listWidget){
				this.listWidget.set("items", []);
			}

			this.clearSearchFlag = true;
			var listProvidersURL = "/ibm/tivoli/rest/providers";
		    var callback = dojo.hitch(this,"_listProvidersCallback");
		    var errorCallback = dojo.hitch(this,"_searchError");

			dojo.xhrGet ({
				url			: listProvidersURL,
				handleAs	: "json",
				preventCache: true,
				content		: { sort: "label" },
				load		: callback,
				error		: errorCallback
			});

			// so that form will not be submitted
			return false;
		},

		_listProvidersCallback: function(result) {
			//console.log ("QueryDatasets.js: _listProvidersCallback: result: ");
			//console.dir (result);
			var items = result.items;
			var providerUrls = [];
			if(items){
				for (i=0; i<items.length; i++) {
					if (items[i].private === undefined || items[i].private !== true) {
						this.providerLabels[items[i].id] = escape(items[i].label);
						providerUrls.push ("/ibm/tivoli/rest/providers/" + encodeURIComponent(items[i].id) + "/datasources");
					} else {
						//console.log ("QueryDatasets.js: provider is private. not searching: " + items[i].id);
					}
				}
			}
			this.providers = result.items;
			this._searchForDatasources (providerUrls);
		},

		_searchForDatasources: function(providerUrls) {
			//console.log ("QueryDatasets.js: enter _searchForDatasources");
		    var callback = dojo.hitch(this,"_searchForDatasourcesCallback");
		    var errorCallback = dojo.hitch(this,"_searchError");
			for (i=0; i<providerUrls.length; i++) {
				dojo.xhrGet({
						url          : providerUrls[i],
		                handleAs     : "json",
	                    preventCache : true,
						content		: { sort: "label" },
    	                load         : callback,
	                    error        : errorCallback
                });
			}
		},

		_searchForDatasourcesCallback: function(result) {
			//console.log ("QueryDatasets.js: enter _searchForDatasourcesCallback");
			//console.log ("QueryDatasets.js: result: ");
			//console.dir (result);
			
			//console.log ("QueryDatasets.js: _searchForDatasourcesCallback: result: ");
			//console.dir (result);

			var items = result.items;
			var urls = [];
			if(items && items.length > 0){
				var provider = this.getProvider (items[0].providerId);
				if (provider.datasources === undefined) {
					provider.datasources = [];
				}
				for (i=0; i<items.length; i++) {
					urls.push ("/ibm/tivoli/rest/providers/" + encodeURIComponent(items[i].providerId) + "/datasources/" + encodeURIComponent(items[i].id));
					// cache the datasources so we can look up the type via id later
					provider.datasources.push (items[i]);
					this.datasetLabels[items[i].providerId + "." + items[i].id] = escape(items[i].label);
				}
			}

			this._searchForDatasets (urls);
		},

		_searchForDatasets: function (search_uris) {
		    //console.log("QueryDatasets.js: enter _searchForDatasets");
		    //debugger;
		    var callback = dojo.hitch(this,"_searchCallback");
		    var errorcallback = dojo.hitch(this,"_searchError");
		    var url = "";
		    var i;
		    this.callcount = 0;
		    //var search_uris = [];
		    //search_uris[0] = "/providers/" + this.widgetSearchConfig.providerId + "/datasources/" + this.widgetSearchConfig.datasourceId;

		    //Get the search value for searchbox.
		    var searchstring = this.searchfield.value;
    		searchstring = encodeURIComponent(searchstring);
			//var uricount = this.search_uris.length;

		    //Make a series of REST/CURI calls and get the list of the macthing datasets for each connection in the connection cache
		    for (var i=0; i< search_uris.length; i++) {
				url = search_uris[i] + "/datasets?condition=( ( label contains '" + searchstring +"' ) or ( description contains '" + searchstring + "' ) or ( type contains '" + searchstring + "' )  or ( id contains '" + searchstring + "' ) )";
				this._fetchInit++;
				dojo.xhrGet({ url  : url,
					handleAs     : "json",
					preventCache : true,
					content		 : { sort: "label" },
					load         : callback,
					error        : errorcallback
				});
    	    }
		},

		_searchError: function (error) {
			this._fetchComplete++;
			console.error (error);
			//msgArea.addMessages("TEDMSG009S", "New validation message added.", "val", "2", "1005");
			//remove dummy message if there
			this.messageArea.removeMessage("0");
			var errorObj = JSON.parse(error.responseText);
			this.messageArea.addMessages(++this.msgId, errorObj.msgText, "error", "5", new Date().getTime());
			this.progressBar.hide();
			//alert (error);
		},

		transitionToDataset: function () {
			console.log ("QueryDatasets.js: enter transitionToDataset");
		},

		_searchCallback: function (result) {
			this.progressBar.show();
			//console.log ("QueryDatasets.js: result: ");
			//console.dir (result);
			var items = result.items;

			//sort the params by label
			/*items.sort(function(a, b){
				if (a.label < b.label) //sort string ascending
					return -1;
				if (a.label > b.label)
					return 1;
				return 0; //default return value (no sorting)
			});*/

			if(items){
				var rowData = new Array();
				for (i=0;i < items.length; i++){
					rowData.push({
						'Name': items[i].label? escapeHTML(items[i].label):items[i].id, //26Oct2012 Bobby: instead of empty row, show id if label is missing
						'ProviderId': items[i].providerId,
						'DatasourceId': items[i].datasourceId,
						'Description': escapeHTML(items[i].description),
						'Identifier': items[i].id,
						'ProviderLabel' : escapeHTML(this.providerLabels[items[i].providerId]),
						'DatasourceLabel' : escapeHTML(this.datasetLabels[items[i].providerId + "." + items[i].datasourceId]),
						'DataType' : items[i].viewType? 'Type:'+items[i].viewType: ""
					});
				}
			}

			if (this.listWidget) {
				//console.log('QueryDatasets.js: reusing listWidget...');
			} else {
				this.listWidget = new List({
					// class:"iconList",
					//Bobby: 12Oct2012, row disappeared on drag/hold
					autoDelete:false,
					enableDelete: false,
					enableHold: false,
					itemTemplate: require.toUrl("dojoe/ssd/quickedit/templates/rowTemplate.html"),
					dividerTemplate:require.toUrl("dojoe/ssd/quickedit/templates/dividerTemplate.html"),
					emptyTemplate:require.toUrl("dojoe/ssd/quickedit/templates/emptyTemplate.html")
				}, this.listWidgetDiv);
				this.listWidget.nls = this.nls;
				//53891: TBSM 35373: QE: Select a dataset: dataset description that includes HTML with single quotes causes browser scripting error
				//Bobby: 11Oct2012, removing onClick from rowTemplate.html				
				dojo.connect(this.listWidget, "onSelect", this, this.onSelect);
				
				this.listWidget.dividerFunction = function(item){
					//console.log("QueryDatasets.js: listWidget.dividerFunction - item:");
					//console.dir(item);
					//return "Provider: "+item.ProviderId+" > Datasource: "+item.DatasourceId;
					var label = unescape(this.nls.DIVIDER_HEADING.replace("%0", item.ProviderLabel).replace("%1", item.DatasourceLabel));
					//console.log("QueryDatasets.js: listWidget.dividerFunction - label:"+label);
					return (label);
				};				
			}


			//var existingItems = this.listWidget.get ("items");

			if (this._existingItems === undefined || this._existingItems === null || this.clearSearchFlag) {
				this._existingItems = [];
				this.clearSearchFlag = false;
			}

			for (j=0; j<rowData.length; j++) {
				this._existingItems.push (rowData[j]);
			}

			this._fetchComplete++;
			//console.debug("this.fetchInit:"+this._fetchInit);			
			//console.debug("this.fetchComplete:"+this._fetchComplete);
			if(this._fetchComplete == this._fetchInit){
				console.info("All fetches complete, updating results list..");
				this.listWidget.set("items", this._existingItems);
				console.info("Total search results:"+this._existingItems.length);
				this.datasetCountNode.innerHTML = this._existingItems.length;
			}
			this.progressBar.hide();
		},

		onSelect: function (data, index, rowNode) {
			//console.info("yahoooo onSelect");
			//console.dir(data);
			quickEdit.getDatasetDetails(
				data.Identifier,
				data.ProviderId, 
				data.DatasourceId, 
				data.Name,
				data.Description,
				data.ProviderLabel,
				data.DatasourceLabel
			);	
		},
		
		getProvider: function (providerId) {
			for (var i=0; i<this.providers.length; i++) {
				if (this.providers[i].id === providerId) {
					return (this.providers[i]);
				}
			}
			console.error("QueryDatasets.js: providerId not found in QueryDatasets.getProvider: " + providerId);
			return (undefined);
		},

		destroy: function () {
			console.debug("QueryDataset.js: destroy()......... BEGIN");
			console.debug('before this.progressBar destroy...');
			if(this.progressBar){
				console.log('found progressBar, going to destroy!');
				//console.dir(this.progressBar);
				this.progressBar.target = null;
				try{
					if (this.progressBar.destroyRecursive) this.progressBar.destroyRecursive();
					else if(this.progressBar.destroy) this.progressBar.destroy();
				}catch (ex) {
					console.warn ("QueryDataset.js: Caught exception in destroy of progressBar:");
					console.warn (ex);
				}
			}
			console.debug('before this.listWidget destroy...');
		  	if(this.listWidget){
				if(this.listWidget.destroyRecursive) this.listWidget.destroyRecursive();
				else if (this.listWidget.destroy) this.listWidget.destroy();
			}
			console.debug('after this.listWidget destroy...');
			this.inherited(arguments);
			console.debug("QueryDataset.js: destroy()......... END");
		}
	});
});
