// wrapped by build app
define("ibm/tivoli/tip/dijit/tests/tivpages/Page2", ["dijit","dojo","dojox","dojo/require!ibm/tivoli/tip/dijit/TivPage,dijit/form/ValidationTextBox,ibm/tivoli/tip/dijit/ListBuilder,dojox/widget/Pager,dojo/data/ItemFileReadStore"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("ibm.tivoli.tip.dijit.tests.tivpages.Page2");

dojo.require("ibm.tivoli.tip.dijit.TivPage");
dojo.require("dijit.form.ValidationTextBox");
dojo.require("ibm.tivoli.tip.dijit.ListBuilder");
dojo.require("dojox.widget.Pager");
dojo.require("dojo.data.ItemFileReadStore");

dojo.declare("ibm.tivoli.tip.dijit.tests.tivpages.Page2", ibm.tivoli.tip.dijit.TivPage, 
{
	templateString:"<div class=\"page2\">\r\n\t<div class=\"tiv-page-header\">\r\n\t\t<h2>General</h2>\r\n\t\t<p>\r\n\t\tThe name and description are required. The catalogs are not.\r\n\t\t</p>\r\n\t</div>\r\n\t<div class=\"tiv-page-content\">\r\n\t\t<label for=\"${id}_name\" class=\"required\">Name:</label>\r\n\t\t<input id=\"${id}_name\" type=\"text\" name=\"widget_name\" dojoType=\"dijit.form.ValidationTextBox\" style=\"width:60%;\" \r\n\t\t\t\trequired=\"true\" regExp=\"[\\w ]+\" dojoAttachEvent=\"onChange:_onPageContentChange\" intermediateChanges=\"true\"/>\r\n\r\n\t\t<label for=\"${id}_desc\" class=\"required\">Description:</label>\r\n\t\t<input id=\"${id}_desc\" type=\"text\" name=\"widget_desc\" dojoType=\"dijit.form.ValidationTextBox\" style=\"width:95%;\" \r\n\t\t\t\trequired=\"true\" regExp=\"[\\w ]+\" dojoAttachEvent=\"onChange:_onPageContentChange\" intermediateChanges=\"true\"/>\r\n\r\n\t\t<div id=\"${id}_catalogs\" dojoType=\"ibm.tivoli.tip.dijit.ListBuilder\" dojoAttachPoint=\"_catalogList\" \r\n\t\t\tshowAllButtons=\"false\" filtered=\"false\" sorted=\"true\" accept=\"catalog\" type=\"catalog\" required=\"false\"\r\n\t\t\tleftLabel=\"Available Catalogs\" rightLabel=\"Selected Catalogs\" name=\"catalog\" \r\n\t\t\tdojoAttachEvent=\"OnChange:_onPageContentChange\"></div> \r\n\t</div>\t\t\t\t\r\n</div>",
	title: "Page 2",

	startup: function()
	{
		if(this._started) return;
		
		this.inherited(arguments);
		this._catalogList.addData(["Sales Metrics", "Fun Metrics", "LOB Metrics", "Call Center Metrics"]);
	},
	
	OnPageSelected: function(myContainer)
	{
    console.log("Page2.OnPageSelected");
		this.inherited(arguments);
		
		// can access parent container by either myContainer argument
		// or by these attributes...
		if (this.notebook)
		  console.info("I am in a notebook: " + this.notebook);
		else if (this.wizard)
		  console.info("I am in a wizard: " + this.wizard);
		else
		  console.info("I'm not in a notebook or wizard: " + myContainer);
	},
	
  AfterPageSelected: function(myContainer)
  {
    console.log("Page2.AfterPageSelected");
    this.inherited(arguments);
  }
});
});
