// wrapped by build app
define("ibm/tivoli/tip/dijit/tests/tivpages/Welcome", ["dijit","dojo","dojox","dojo/require!ibm/tivoli/tip/dijit/TivPage"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("ibm.tivoli.tip.dijit.tests.tivpages.Welcome");

dojo.require("ibm.tivoli.tip.dijit.TivPage");

dojo.declare("ibm.tivoli.tip.dijit.tests.tivpages.Welcome", ibm.tivoli.tip.dijit.TivPage, 
{
  templateString:"<div>\r\n\t<div class=\"tiv-page-header\">\r\n\t\t<h2>Welcome</h2>\r\n\t</div>\r\n\t<div class=\"tiv-page-content\">\r\n\t\tThis test of the TIP wizard will walk you through the following:\r\n\t\t<ul>\r\n\t\t<li>Naming and describing the widget</li>\r\n\t\t<li>Protect the new component by adding or removing roles</li>\r\n\t\t<li>Customize the settings for the widget after finishing the wizard</li>\r\n\t\t</ul>\r\n\t</div>\r\n\t<div style=\"margin-top:1em;\">Press next to begin.</div>\t\t\t\t\t\r\n\t<div style=\"margin-top:12em;background-color:yellow\" dojoAttachPoint=\"msgarea\"></div>\r\n</div>\r\n",
  title: "Welcome",
  
  OnPageSelected: function(myContainer)
  {
    this.inherited(arguments);
    
    var msg;

    if (myContainer.nested) {
    
      // can access parent container by either myContainer argument
      // or by these attributes...
      if (this.notebook)
        msg = "I am a nested notebook: " + this.notebook.id;
      else if (this.wizard)
        msg = "I am a nested wizard: " + this.wizard.id;
      else
        msg = "Hmm, I am a nested container that is neither a notebook or wizard: " + myContainer.id;

      // set msgarea html
      this.msgarea.innerHTML = msg;
    }
  }

});

});
