// wrapped by build app
define("ibm/tivoli/tip/dijit/tests/tivwizard_pages/TestPage3", ["dijit","dojo","dojox","dojo/require!ibm/tivoli/tip/dijit/TivPage"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("ibm.tivoli.tip.dijit.tests.tivwizard_pages.TestPage3");

dojo.require("ibm.tivoli.tip.dijit.TivPage");

dojo.declare("ibm.tivoli.tip.dijit.tests.tivwizard_pages.TestPage3", [ibm.tivoli.tip.dijit.TivPage], 
{
  templateString:"<div class=\"page3\">\r\n  <div class=\"tiv-page-header\">\r\n    <h2>Page 3</h2>\r\n    <p>A page with substeps</p>\r\n    <p>Finish button now enabled</p>\r\n  </div>\r\n  <div class=\"tiv-page-content\">\r\n    <h4>Testing substeps</h4>\r\n    <input dojoAttachPoint=\"_skipper\" type=\"button\" value=\"Skipper\"></input>\r\n  </div>\r\n</div>\r\n",
  title: "Page 3",
  skipHandler: null,

  postCreate: function ()
  {
    console.log("TestPage3.postCreate");

    this.inherited(arguments);

    this.skipHandler = dojo.connect(this._skipper, "onclick", this, this.doSkip);
  },

  AfterPageSelected: function ()
  {
    this.wizard.resetFinishLabel("Finish");
    this.wizard.enableFinishButton(true);
  },

  doSkip: function (event)
  {
    console.log("TestPage3.doSkip");

    // mark all sub-steps as complete
    var aPageNode = dojo.query(".substep1", this.wizard.domNode);
    if (aPageNode != null)
      dijit.getEnclosingWidget(aPageNode[0]).attr("visited", true);
    aPageNode = dojo.query(".substep2", this.wizard.domNode);
    if (aPageNode != null)
      dijit.getEnclosingWidget(aPageNode[0]).attr("visited", true);
    aPageNode = dojo.query(".substep3", this.wizard.domNode);
    if (aPageNode != null)
      dijit.getEnclosingWidget(aPageNode[0]).attr("visited", true);
    
    // skip to next main task
    this.wizard.skipToNextMainStep();    
  }  
});

});
