require({cache:{
'url:ibm/usmi/dashboard/templates/ResourceDashBoard.html':"<div class=\"res-dashboard\">\r\n<!--\r\n\r\nLicensed Materials - Property of IBM\r\n\r\n(C) Copyright IBM Corp. 2012 All Rights Reserved\r\n\r\nUS Government Users Restricted Rights - Use, duplicate or\r\ndisclosure restricted by GSA ADP Schedule Contract with\r\nIBM Corp.\r\n\r\n-->\r\n\t<div id=\"dashbaordFullContainer\" data-dojo-type=\"dijit.layout.BorderContainer\" data-dojo-props=\"design: 'headline', gutters: false\" class=\"spacious\" style=\"padding:0; margin:0;\">\r\n\t\t<div id=\"dashBoardGroupsContainer\" data-dojo-props=\"region: 'left'\" data-dojo-type=\"dijit.layout.ContentPane\">\r\n\t\t\t\t\t<div id=\"chassisPane\" class=\"dashboardGroup\">\r\n\t\t\t\t\t\t<div id=\"chassis\"></div>\r\n\t\t\t\t\t</div>\r\n\t\t\t\t\t<div id=\"virtualserversPane\" class=\"dashboardGroup\">\r\n\t\t\t\t\t\t<div id=\"virtualservers\"></div>\r\n\t\t\t\t\t</div>\r\n\t\t\t\t\t<div id=\"networkPane\" class=\"dashboardGroup\">\r\n\t\t\t\t\t\t<div id=\"network\"></div>\r\n\t\t\t\t\t</div>\r\n\t\t\t\t\t<div id=\"storagePane\" class=\"dashboardGroup\">\r\n\t\t\t\t\t\t<div id=\"storage\"></div>\r\n\t\t\t\t\t</div>\r\n\t\t\t\t\t<div id=\"favoritesPane\" class=\"dashboardGroup\">\r\n\t\t\t\t\t\t<div id=\"favorites\"></div>\r\n\t\t\t\t\t</div>\r\n\t\t\t\t\t<div id=\"systemsPane\" data-dojo-type=\"dijit.layout.ContentPane\" data-dojo-props=\"splitter:false, region:'leading', layoutPriority:1\" class=\"dashboardGroup\">\r\n\t\t\t\t\t\t<div id=\"systems\"></div>\r\n\t\t\t\t\t</div>\r\n\t\t</div>\r\n\t\t\r\n\t\t<div id=\"dashboardSelectorContainer\" data-dojo-props=\"region: 'center', splitter: false\" data-dojo-type=\"dijit.layout.ContentPane\" class=\"dashboardSelectorContainer\">\r\n\t\t\t<div id=\"dashboard_selectorTreeTopper\" style=\"width:100%;\"></div>\r\n\t\t\t<div id=\"dashboard_selectorTree\" style=\"width:100%; height:100%;\"></div>\r\n\t\t</div>\r\n\r\n\t</div>\r\n </div>"}});
/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012, 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define(
		"ibm/usmi/dashboard/ResourceDashBoard", [
			"ibm/tivoli/tip/TCTTable",
			"ibm/tivoli/navmodel/Selection",
			"dojo/_base/kernel",
			"dojo/_base/declare",
			"dijit/_WidgetBase",
			"dijit/_TemplatedMixin",
			"dijit/_WidgetsInTemplateMixin",
			"./ResourceGroup",
			"./ResourceGroupWidget",
			"./DashBoardResourceNavigator",
			"dojo/text!./templates/ResourceDashBoard.html",
			"./Constants",
			"ibm/usmi/widgets/util/Constants",
			"dojo/topic",
			"ibm/usmi/util/BaseWidget",
			"ibm/usmi/core/utils/Logger",
			"ibm/usmi/core/utils/_UsmiBrowserPersistence",
			"dojo/hash",
			"dojo/io-query",
			"dojo/_base/connect",
			"dojo/_base/array",
			"dojo/dom-construct",
			"ibm/usmi/widgets/TreeSelector",
			"ibm/usmi/widgets/TreeTopperLinks",
			"ibm/usmi/widgets/TreeTopper",
			"dijit/registry",
			"dojo/dom-class",
			"dijit/layout/ContentPane",
			"dijit/layout/BorderContainer",
			"ibm/usmi/util/DataStore",
			"dojo/i18n!./nls/DashbarResources",
			"ibm/usmi/util/DefaultMessageHandler",
			"dojo/_base/lang",
			"dojo/dom-style",
			"dojo/dom"
		],
		function (TCTTable, Selection, dojo, declare, WidgetBase, TemplatedMixin, WidgetsInTemplateMixin,
				ResourceGroup, ResourceGroupWidget, DashBoardResourceNavigator, template, Constants, WidgetConstants,
				topic, BaseWidget, Logger, _UsmiBrowserPersistence, hash, ioQuery, connect, array, domConstruct,
				SelectorTree, TreeTopperLinks, TreeTopper, registry, domClass, ContentPane, BorderContainer, DataStore,
				mri, DefaultMessageHandler, lang, domStyle, dom) {
			return declare(
					"ibm.usmi.dashboard.ResourceDashBoard",
					[
						WidgetBase,
						TemplatedMixin,
						WidgetsInTemplateMixin,
						BaseWidget,
						_UsmiBrowserPersistence
					],
					{

						// Template info:  Path
						templateString : template,

						// array of dash board resource groups objects
						resourceGroups : {},

						// array of dash board resource group widgets
						resourceGroupWidgets : null,

						// Tree selector widget
						selector : null,

						// Tree topper widget
						treeTopper : null,

						// Id of resource group currently selected
						_prevSelectionGroup : "",

						// Id of curently selector group
						_selectedGroup : "",

						//Subscriptions to clean up
						_subscriptions : null,

						// convenience wrapper for dataset
						_dataStore : null,

						_dashbar : null,
						_registerStatusListenerTask : null,

						//resource bundle
						_resources : mri,

						// the logger
						_resourceDashBoardLogger : new Logger("ibm.usmi.dashboard", "ResourceDashBoard"),

						// summary:
						//         Called after a widget's dom has been setup
						// tags:
						//        protected

						postCreate : function () {
							this._subscriptions = [];
							this.resourceGroupWidgets = [];
							this.inherited(arguments);

							// subscribe to workarea isReady event
							this._subscriptions.push(connect.subscribe(WidgetConstants.TOPIC_READY_WORKAREA, this,
									this.workAreaIsActive));

							this._dataStore = new DataStore({
								datasetId : 'DashbarCollection',
								homeParms : null,
								getItems : true,
								retrieveItemProperties : true,
								getTasks : false,
								initReadyCallback : dojo.hitch(this, this.initializeDataStores)
							});
						},

						initializeDataStores : function () {
							if (this._resourceDashBoardLogger.isInfo()) {
								this._resourceDashBoardLogger
										.info(
												"Dashbar data retrieved from server. Converting CURI data into the dashbar object",
												"initializeDataStores");
							}

							this._dataStore.getDataset().addEventListener(this, lang.hitch(this, this._eventHandler));

							this._createDashBar();
						},

						/*
						* Called after getting tasks on the dataset. 
						* Will be used for registering a status listener 
						* after page is painted 
						*/
						_getTasksComplete : function (itemId, tasks) {
							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.entering("", "_getTasksComplete");
							}

							var taskExecuteComplete = dojo.hitch(this, function () {
								if (this._resourceDashBoardLogger.isFinest()) {
									this._resourceDashBoardLogger.finest("ran server side task to register listeners",
											"taskExecuteComplete");
								}

							});

							//if we got the task back, run it
							if (tasks[0]) {
								var selection = new Selection({
									version : ""
								});
								selection.addItem(itemId);
								tasks[0].execute({
									onComplete : dojo.hitch(this, taskExecuteComplete),
									selection : selection
								});
							}
							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.exiting("", "_getTasksComplete");
							}

						},

						/**
						 * converts a collection into a dashbar objects for easy
						 * storage in session persistence
						 */
						_convertDashbarCollectiontoDashbarObject : function () {
							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.entering("", "_convertDashbarCollectiontoDashbarObject");
							}
							var items, id, title, image, collection, groupID, widgetPathKey, widgetPath, widget, hasSelector, topperLinks, count, status, groupOID;

							items = this._dataStore.getItems();

							this._dashbar = {
								"dashbarItems" : []
							};

							//    First create the menus themselves reading from the collection.
							//    Once the menus are created, then read through the
							//    collection to populate them.
							dojo.forEach(items, dojo.hitch(this, function (entry, i) {
								id = entry.getProperty('ID_PROP').getValue();
								title = entry.getProperty('TITLE_PROP').getValue();
								image = entry.getProperty('IMAGE_PROP').getValue();
								collection = entry.getProperty('COLLECTION_PROP').getValue();
								groupID = entry.getProperty('GROUP_PROP').getValue();
								widget = entry.getProperty('WIDGET_PROP').getValue();
								widgetPathKey = entry.getProperty('WIDGET_PATH_KEY_PROP').getValue();
								widgetPath = entry.getProperty('WIDGET_PATH_PROP').getValue();
								hasSelector = entry.getProperty('HAS_SELECTOR_PROP').getValue();
								topperLinks = entry.getProperty('TOPPER_STRING_PROP').getValue();
								count = entry.getProperty('GROUP_COUNT_PROP').getValue();
								status = entry.getProperty('GROUP_STATUS_PROP').getValue();
								groupOID = entry.getProperty('GROUP_OID_PROP').getValue();

								this._dashbar.dashbarItems.push({
									"id" : id,
									"title" : title,
									"image" : image,
									"collection" : collection,
									"groupID" : groupID,
									"widgetPathKey" : widgetPathKey,
									"widgetPath" : widgetPath,
									"widget" : widget,
									"hasSelector" : hasSelector,
									"topperLinks" : topperLinks,
									"groupCount" : count,
									"groupStatus" : status,
									"groupOID" : groupOID
								});
							}));

							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.exiting("", "_convertDashbarCollectiontoDashbarObject");
							}
						},

						/**
						 * creates the menu headings from a menu bar object
						 * that's created from a collection, creates a new popup
						 * menu bar item, menu dialog, and submenu for each one.
						 */
						_createDashBar : function () {
							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.entering("Creating a menu bar with "
										+ this._dataStore.getItems().length + " menus", "_createDashBar");
							}

							var dashItemTitleKey, hashStr = hash(), hashObj, persistedSelectedGroup, hashStr2, items, groupOnUrl = false;

							this._selectedGroup = "systems";

							// If chassis exists make it the default view
							items = this._dataStore.getItems();
							for ( var i = 0; i < items.length; i += 1) {
								var id = items[i].getProperty('ID_PROP').getValue();
								if (id === "chassis") {
									this._selectedGroup = "chassis";
									break;
								}
							}

							// check the hash value
							if (hashStr) {
								// if hash is set, get the selected group value
								hashObj = ioQuery.queryToObject(hashStr);

								// if hash has selectedGroup specified, that is what we will use
								if (hashObj.selectedGroup) {
									this._selectedGroup = hashObj.selectedGroup;

									// set the previous, so we dont process a hashupdate for this
									this._prevSelectionGroup = this._selectedGroup;
									groupOnUrl = true;
								} else {
									// lets check to see if a selectedGroup was stored off into persistence, if so use it
									persistedSelectedGroup = this.getData("selectedGrpkey", true);
									if (persistedSelectedGroup) {
										this._selectedGroup = persistedSelectedGroup.selectedGroup;
									}

									hashObj.selectedGroup = this._selectedGroup;
									hashStr2 = ioQuery.objectToQuery(hashObj);
									hash(hashStr2, true);
								}
							} else {
								// initialize to "systems" dash board group to be selected.
								hashObj = {
									"selectedGroup" : this._selectedGroup,
									"workAreaDijit" : "ibm/usmi/widgets/WorkArea",
									"selector" : "ibm/usmi/dashboard/ResourceDashBoard"
								};
								// base widget utility method to add object to hash
								this.setUrlHashObj(hashObj);
							}

							items = this._dataStore.getItems();
							dojo.forEach(items, dojo.hitch(this, function (dashbarItem, i) {
								var selected = false, resourceGroup, resouceGroupWidget, dashItemID;

								dashItemTitleKey = dashbarItem.getProperty('TITLE_PROP').getValue();
								dashItemID = dashbarItem.getProperty('ID_PROP').getValue();

								if (this._resourceDashBoardLogger.isFinest()) {
									this._resourceDashBoardLogger.finest("Creating dashbar item: " + dashItemTitleKey,
											"_createDashBar");
								}

								// set selected on group that was set on hash
								if (this._selectedGroup === dashItemID) {
									selected = true;
								}

								// create a resource Group Object
								resourceGroup = new ResourceGroup({
									name : dashItemID,
									label : this._resources[dashItemTitleKey],
									dataSetID : dashbarItem.getProperty('COLLECTION_PROP').getValue(),
									widgetID : dashbarItem.getProperty('WIDGET_PROP').getValue(),
									widgetPathKey : dashbarItem.getProperty('WIDGET_PATH_KEY_PROP').getValue(),
									widgetPath : dashbarItem.getProperty('WIDGET_PATH_PROP').getValue(),
									groupID : dashbarItem.getProperty('GROUP_PROP').getValue(),
									selectorHome : dashbarItem.getProperty('COLLECTION_PROP').getValue(),
									hasSelector : dashbarItem.getProperty('HAS_SELECTOR_PROP').getValue(),
									topperLinks : dashbarItem.getProperty('TOPPER_STRING_PROP').getValue(),
									selected : selected,
									groupCount : dashbarItem.getProperty('GROUP_COUNT_PROP').getValue(),
									groupOID : dashbarItem.getProperty('GROUP_OID_PROP').getValue()
								});

								// add the resource Group to local array
								this.resourceGroups[dashItemID] = resourceGroup;

								// create a resource Group Widget
								resouceGroupWidget = new ResourceGroupWidget({
									resourceGroup : resourceGroup
								}, dashItemID);

								// load up the widget with initial data
								resouceGroupWidget.loadSystemStatus();

								// add this widget to widget array
								this.resourceGroupWidgets.push(resouceGroupWidget);
							}));

							// Listen for hash updates
							this._subscriptions.push(connect.subscribe(WidgetConstants.TOPIC_HASH_CHANGE, this,
									this.hashChange));
							// Listen if resourceGroup has been re-selected
							this._subscriptions.push(connect.subscribe(Constants.resourceGroupSelected, this, function (
									message) {
								this._update(message);
							}));

							//kick off an update if group was set on URl, if not we set the hash up above, which will
							// kick off hash update which will call _update
							if (groupOnUrl === true) {
								this._update(this._selectedGroup);
							}

							//everything's setup at this point. Lets get status and update it if necessary
							var ds = this._dataStore.getDataset();
							//get these individually so we can set up listeners individually.
							ds.getTasks({
								sync : true,
								onComplete : dojo.hitch(this, function (tasks) {
									this._registerStatusListenerTask = tasks[0];
								})
							});

							for ( var itemNum = 0; itemNum < this._dataStore.getItems().length; itemNum++) {
								this._getTasksComplete(items[itemNum].getId(), [ this._registerStatusListenerTask
								]);
							}

							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.exiting("", "_createDashBar");
							}
						},

						startup : function () {
							// summary:
							//         Called after any DOM fragments have been actually added to the document,
							//           not fired until
							//         after any potential children widgets have been created
							// tags:
							//        protected

							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.entering("", "startup");
							}

							this.inherited(arguments);

							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.exiting("", "startup");
							}
						},

						workAreaIsActive : function () {
						//        this._update(this._selectedGroup);
						},

						hashChange : function (hash) {
							var hashObj = ioQuery.queryToObject(hash), selectedGroup = hashObj.selectedGroup;
							if (selectedGroup && (this._prevSelectionGroup !== selectedGroup)) {
								topic.publish(WidgetConstants.TOPIC_TASK_TITLE_CHANGE, {
									view : "Resource Dashboard: " + this.resourceGroups[selectedGroup].label
								});

								// store the selectedGroup
								this._prevSelectionGroup = selectedGroup;
								// kick off the update
								this._update(selectedGroup);

								// store the entire hash off for now.
								if (this._resourceDashBoardLogger.isFiner()) {
									this._resourceDashBoardLogger.finer("save off dashboard selection", "hashChange");
								}
								this.setData("selectedGrpkey", hashObj, true);
							}
						},

						_createSelectorTopper : function (groupName) {
							// summary:
							//     If resource group widget needs a tree selector, check to see if it has base nodes to go
							//     above the tree, for example "All Virtual Servers"
							// tags:
							//     private

							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.entering("", "_createSelectorTopper");
							}

							var topperLabel, topperLinksString, topperLinksArray, topperLinkObj, topperLinkTitleKey, treeTopperNode, i, resourceGroup;

							resourceGroup = this.resourceGroups[groupName];
							topperLabel = resourceGroup.getLabel();

							// create the tree topper that sits above the tree selector
							this.treeTopper = new TreeTopper({
								label : topperLabel,
								style : "width:100%; height:100%;"
							}, domConstruct.create("DIV"));

							topperLinksString = resourceGroup.getTopperLinks();
							// check to see if topper links were specified in dashbar.json
							if (topperLinksString) {
								topperLinksArray = JSON.parse(topperLinksString);

								// loop trough topperlink specified in json and construct TreeTopperLinks for each
								if (topperLinksArray) {
									for (i = 0; i < topperLinksArray.length; i += 1) {
										topperLinkObj = topperLinksArray[i];
										topperLinkTitleKey = topperLinkObj.title;
										// construct the tree selector
										treeTopperNode = new TreeTopperLinks({
											topperId : topperLinkObj.id,
											label : this._resources[topperLinkTitleKey],
											collectionID : topperLinkObj.collectionID,
											taskWidgetPathKey : topperLinkObj.widgetPathKey,
											taskWidgetPath : topperLinkObj.widgetPath,
											taskWidgetId : topperLinkObj.widgetID,
											icon : topperLinkObj.image
										});

										this.treeTopper.addTreeTopperLink(treeTopperNode);
									}

									this.treeTopper.placeAt("dashboard_selectorTreeTopper");
									this.treeTopper.startup();
								}
							}

							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.exiting("", "_createSelectorTopper");
							}
						},

						_createSelector : function (groupName, dashboardContainer, selectorCPane,
								outermostBorderContainer) {
							// summary:
							//     If resource group widget needs a tree selector, this method is called to
							//       create selector and add it to the page.
							// tags:
							//     private

							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.entering("", "_createSelector");
							}

							// set the size of the selector pane, tree selector plus dashboard widget
							selectorCPane.setAttribute('style', "width: 460px;");

							// construct the tree selector, passing in dataset
							this.selector = new SelectorTree({
								id : "resourceViewTreeSelector",
								selectorHome : this.resourceGroups[groupName].selectorHome,
								defaultTaskSelectionPathKey : this.resourceGroups[groupName].widgetPathKey,
								defaultTaskSelectionPath : this.resourceGroups[groupName].widgetPath,
								defaultTaskSelectionWidget : this.resourceGroups[groupName].widgetID,
								style : "width:305px; height:100%;padding:0px;margin-left: 5px;"
							}, domConstruct.create("DIV"));
							this.selector.placeAt("dashboard_selectorTree");
							this.selector.startup();

							// call resize on the main div to resize to content
							outermostBorderContainer.resize();

							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.exiting("", "_createSelector");
							}
						},

						_getTreeCalculatedHeight : function () {
							var topperNode, containerNode, topperHeight, selectorHeight, calculated = "100%";
							topperNode = dojo.byId("dashboard_selectorTreeTopper");
							containerNode = dojo.byId("dashbaordFullContainer");
							if (topperNode && containerNode) {
								topperHeight = dojo.getContentBox(topperNode).h;
								selectorHeight = dojo.getContentBox(containerNode).h;
								calculated = selectorHeight - topperHeight - 30 + "px";

								if (this._resourceDashBoardLogger.isFinest()) {
									this._resourceDashBoardLogger.finest("getTreeCalculatedHeight, topper height: "
											+ topperHeight);
									this._resourceDashBoardLogger.finest("getTreeCalculatedHeight, selector height: "
											+ selectorHeight);
									this._resourceDashBoardLogger.finest("getTreeCalculatedHeight, calced height: "
											+ calculated);
								}
							} else if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.finest("getTreeCalculatedHeight, nodes not found");
							}
							return calculated;
						},

						resize : function () {
							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.finest("resize resourcedashboard");
							}
							this.inherited(arguments);

							var resTreeDomNode = dom.byId("dashboard_selectorTree");
							if (resTreeDomNode) {
								var calculatedHeight = this._getTreeCalculatedHeight();
								domStyle.set(resTreeDomNode, "height", calculatedHeight);
								if (this._resourceDashBoardLogger.isFinest()) {
									this._resourceDashBoardLogger.finest("resize resourcedashboard, calced height: "
											+ calculatedHeight);
									this._resourceDashBoardLogger.finest("resize resourcedashboard, tree selector: "
											+ registry.byId("resourceViewTreeSelector"));
								}
							} //end tree resize
						},

						_update : function (groupName) {
							// summary:
							//     Called when a dash board widget is selected.   Creates/destroys selector continer
							//        based on need.
							// tags:
							//     private

							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.entering("", "_update");
							}

							var showSelector, dashboarLayout, dashboardSelectorContainer, selectorDomNode,
							selectorContentPane, outermostBorderContainer;

							// if selector was previously shown, destroy
							if (this.selector) {
								this.treeTopper.destroyRecursive();
								this.selector.destroyRecursive();
							}

							// get the selector home dataset id
							showSelector = this.resourceGroups[groupName].hasSelector;

							// get the dash board's border container
							dashboarLayout = registry.byId("dashbaordFullContainer");
							// get the dash board's selector content pane
							dashboardSelectorContainer = registry.byId("dashboardSelectorContainer");
							// get the frameworks selector content pane
							selectorContentPane = registry.byId("selectorContainer");
							// get the frameworks border container, used to resize the slider
							outermostBorderContainer = registry.byId("contentAreaLayout");

							// if there is no selectorHome for selected dash board widget, but the dash board content
							//pane exists need to remove and destroy it
							if (!showSelector && dashboardSelectorContainer) {
								try {
									if (this._resourceDashBoardLogger.isFinest()) {
										this._resourceDashBoardLogger.finest("removing child");
									}
									dashboarLayout.removeChild(dashboardSelectorContainer);

									if (this._resourceDashBoardLogger.isFinest()) {
										this._resourceDashBoardLogger.finest("destroying selector contentpane");
									}
									dashboardSelectorContainer.destroyRecursive();
									selectorContentPane.setAttribute('style', "width: 165px;");

									if (this._resourceDashBoardLogger.isFinest()) {
										this._resourceDashBoardLogger
												.finest("successfully destoryed selector container");
									}

									// resize the border container, so fits contents of panes
									outermostBorderContainer.resize();
								} catch (ex) {
									if (this._resourceDashBoardLogger.isError()) {
										this._resourceDashBoardLogger.error("udpate failed: " + ex, "_update");
									}
								}
							}

							// if there is a selectorHome for selected dash board widget, but the dash board content pane
							//exists need to create it and add
							if (showSelector && !dashboardSelectorContainer) {
								dashboardSelectorContainer = new ContentPane({
									id : "dashboardSelectorContainer",
									region : 'left',
									splitter : false,
									style : 'width:310px;'
								}, domConstruct.create("DIV", {
									id : "dashboardSelectorContainer"
								}));
								domClass.add(dashboardSelectorContainer.domNode, "dashboardSelectorContainer");

								// create the selectorTreeTopper dom node
								domConstruct.create("DIV", {
									id : "dashboard_selectorTreeTopper",
									style : 'width:100%;'
								}, dashboardSelectorContainer.domNode);


								// create the selectorTree dom node
								selectorDomNode = domConstruct.create("DIV", {
									id : "dashboard_selectorTree",
									style : 'width:100%;height:100%'
								}, dashboardSelectorContainer.domNode);
								domClass.add(selectorDomNode, "interiorSpacious");
								dashboarLayout.addChild(dashboardSelectorContainer);
							}

							//

							// if tree selector is needed create one, and it will control what is shown in workarea
							if (showSelector) {
								// make sure the width is set to hold selector, when coming from a bookmark, width is not set
								// appropriately, so get a half tree
								dashboardSelectorContainer.setAttribute('style', 'width:310px;height:100%;');
								// create nodes that go above the tree
								this._createSelectorTopper(groupName);
								this._createSelector(groupName, dashboarLayout, selectorContentPane,
										outermostBorderContainer);
							} else {
								// no tree selector, so we need to tell the workarea what to show
								this._setTableDetails(groupName);
							}

							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.exiting("", "_update");
							}
							dijit.byId("pageLayout").resize();
						},

						_setTableDetails : function (groupName) {
							// summary:
							//     If resource group widget does not need a tree selector, this method is called to
							//       setup hash parms so work area widet can load correclty.
							// tags:
							//     private

							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.entering("", "_setTableDetails");
							}

							var taskSelection, taskPathKey = "", taskPath = "", datasetCollectionName, taskInfoObj = {};

							// set the task path key if set 
							if (this.resourceGroups[groupName] && this.resourceGroups[groupName].widgetPathKey) {
								taskPathKey = this.resourceGroups[groupName].widgetPathKey;
							}

							// set the task path if set 
							if (this.resourceGroups[groupName] && this.resourceGroups[groupName].widgetPath) {
								taskPath = this.resourceGroups[groupName].widgetPath;
							}

							// default task selection widget if one was not specified in dashbar.json
							if (this.resourceGroups[groupName] && this.resourceGroups[groupName].widgetID) {
								taskSelection = this.resourceGroups[groupName].widgetID;
							} else {
								taskSelection = WidgetConstants.DEFAULT_TASK_SELECTION_WIDGET;
							}

							if (this.resourceGroups[groupName] && this.resourceGroups[groupName].dataSetID) {
								datasetCollectionName = this.resourceGroups[groupName].dataSetID;
							} else {
								datasetCollectionName = "GROUP:ALL_ENDPOINTS";
							}

							taskInfoObj[WidgetConstants.COLLECTION] = datasetCollectionName;
							taskInfoObj[WidgetConstants.HASH_TASK_PATH_KEY] = taskPathKey;
							taskInfoObj[WidgetConstants.HASH_TASK_PATH] = taskPath;
							taskInfoObj[WidgetConstants.HASH_TASK_SELECTION] = taskSelection;
							taskInfoObj[WidgetConstants.SOURCE_TOKEN] = this.sourceToken;
							topic.publish(WidgetConstants.TOPIC_RETARGET_INFO, taskInfoObj);

							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.exiting("", "_setTableDetails");
							}
						},

						_eventHandler : function (listenerObject, event) {
							// summary:
							//         Handle dataset events
							// tags:
							//     callback

							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.entering("", "_eventHandler");
								this._resourceDashBoardLogger.finest("#***ResourceDashBoard- event datasetId="
										+ event.getDataset().getId() + " event=" + event.getType() + " eventId="
										+ event.getId());
							}

							var itemID, property, newCount, newStatus;
							if (event.getType() === "itemPropertiesChanged") {

								// This is the event that is fired when a member is added / removed
								for ( var nodeNum = 0; nodeNum < event.getItems().length; nodeNum++) {
									itemID = event.getItems()[nodeNum].getId();
									array.forEach(listenerObject.resourceGroupWidgets, function (resourceGroupWidget) {
										if (this._resourceDashBoardLogger.isFinest()) {
											this._resourceDashBoardLogger.finest(
													resourceGroupWidget.resourceGroup.name, "_eventHandler");
										}

										// need to convert itemId to integer to do compare against group OID
										// radix is 10 (decimal)
										itemID = parseInt(itemID, 10);
										if (itemID === resourceGroupWidget.getResourceGroupGroupOID()) {
											// get count of property, set new value                         
											property = event.getProperties()[nodeNum][0];
											if (property.getId() === "GROUP_COUNT_PROP") {
												newCount = property.getValue();
												resourceGroupWidget.updateCount(newCount);
											} else if (property.getId() === "GROUP_STATUS_PROP") {
												newStatus = property.getValue();
												resourceGroupWidget.updateStatus(newStatus);
											}

											if (this._resourceDashBoardLogger.isFinest()) {
												this._resourceDashBoardLogger.finest("refreshed resource "
														+ resourceGroupWidget.resourceGroup.name, "_eventHandler");
											}
										}
									}, listenerObject);
								}
							}

							if (this._resourceDashBoardLogger.isFinest()) {
								this._resourceDashBoardLogger.exiting("", "eventHandler");
							}
						},

						destroy : function () {
							// clean up subscriptions
							var idx = 0;
							for (; idx < this._subscriptions.length; idx++) {
								this._subscriptions[idx].remove();
							}
							this._subscriptions.length = 0;

							// cleanup widgets array
							var idy = 0;
							for (; idy < this.resourceGroupWidgets.length; idy++) {
								this.resourceGroupWidgets[idy].destroy();
							}

							//Clear out the array
							this.resourceGroupWidgets.splice(0);

							// clean up the datastore
							if (this._dataStore) {
								this._dataStore.getDataset().removeEventListener(this);
								this._dataStore.destroy();
								this._dataStore = null;
							}

							this.inherited(arguments);
						},

						destroyRecursive : function () {
							this.inherited(arguments);
						}

					});
		});
