require({cache:{
'url:dojoe/ssd/quickedit/templates/TopologyOptions.html':"<div class=\"topologyoptions\" style=\"height:100%;width:100%;\"> \n\t<div class=\"tablelayout\">\n\t  <table class=\"rows\">\n\t\t<tr>\n\t\t  <td>\n\t\t\t<table>\n\t\t\t\t<tr style=\"background: inherit;font-weight:bold;\">\n\t\t\t\t\t<td data-dojo-attach-point=\"displayAsTable_Label_Node\"></td> \n\t\t\t\t</tr>\n\t\t\t\t<tr style=\"background: inherit;font-style:italic;\">\n\t\t\t\t\t<td data-dojo-attach-point=\"displayAsTable_Desc_Node\" style=\"font-size:80%;\"></td>\n\t\t\t\t</tr>\n\t\t\t </table>\t\n\t\t  </td>\n\t\t  <td data-dojo-attach-point=\"displayAsTable_Value_Node\"></td>\n\t\t</tr>\t\t\t\t\n\t </table> \n\t</div>\n</div>\t"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/ssd/quickedit/TopologyOptions", [
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dojo/text!./templates/TopologyOptions.html",
	"dojo/i18n!./nls/TopologyOptions",
	'dijit/form/CheckBox'
], function (declare,lang,_WidgetBase, _TemplatedMixin, template, nlsBundle, CheckBox) {
	 return declare("dojoe.ssd.quickedit.TopologyOptions", [_WidgetBase, _TemplatedMixin], {
		templateString: template,
		nls: nlsBundle,
		_datasetColumns: null,
				
		postCreate:function () {					
			this.displayAsTable_Label_Node.innerHTML = this.nls.NAME_DISPLAY_AS_TABLE;
			this.displayAsTable_Desc_Node.innerHTML = this.nls.DESC_DISPLAY_AS_TABLE;	
			
			this.displayAsTable_Value = new CheckBox({value: false, checked: false});	
			this.displayAsTable_Value_Node.appendChild(this.displayAsTable_Value.domNode);	
		},
		
		_processDatasetColumns: function(columns) {
			console.debug("TopologyOptions._processDatasetColumns... BEGIN");
			this._datasetColumns = new Array();
			/* Don't need this currently...
			this._datasetColumns.push({value:"None", label:this.nls.NAME_NONE, selected: true});			
			var datasetColumnsTemp = new Array();					
		
			for (var i=0;i<columns.length;i++){
				//exclude hidden columns from dataset
				if(!columns[i].isHidden()){
					datasetColumnsTemp.push({
						value: columns[i].getId(), 
						label: columns[i].getLabel(), 
						valueType: columns[i].getValueType()
					});			
				}	
			}			

			//sort the dataset columns
			datasetColumnsTemp.sort(function(a, b){
				if (a.label < b.label) //sort string ascending
					return -1;
				if (a.label > b.label)
					return 1;
				return 0; //default return value (no sorting)
			});			
			
			this._datasetColumns = this._datasetColumns.concat(datasetColumnsTemp);
			
			console.info("Dataset Attributes...");
			console.dir(this._datasetColumns);
			*/
			this._initialize();					
			console.debug("TopologyOptions._processDatasetColumns... END");
		},		
		
		_initialize: function() {	
			console.debug("TopologyOptions._initialize... BEGIN");
			var attribName;		
			//check whether option is in preferences				
			for(var j=0;j<dashletConfig.optionNameArr.length;j++){
				attribName = dashletConfig.optionNameArr[j].replace("qe_optn_",""); 				
				if(attribName == 'DisplayAsTable'){
					this.displayAsTable_Value.set("value",dashletConfig.optionValueArr[j]);
					if(dashletConfig.optionValueArr[j] == 'false')
						this.displayAsTable_Value.set("checked",false);
					else this.displayAsTable_Value.set("checked",true);	
				}			
			}			
			console.debug("TopologyOptions._initialize... END");
		},	
		
		createOptionsGrid: function () {
			console.debug("TopologyOptions.createOptionsGrid... BEGIN");	
			quickEdit.getDatasetColumns(this, "_processDatasetColumns");
			console.debug ("TopologyOptions.createOptionsGrid... END");				
		},	
			
		//This is expected out of any Custom Options widget
		//QuickEditController.js looks for this method to get current UI state when 'OK' is pressed
		//This value is stored in prefrences and View JSP retrieves from there
		getQuickEditOptionsString: function () {
			var quickEditOptions="";							
			//When checkbox is selected 'on' is returned, need to map to true!
			if(this.displayAsTable_Value.get('value')+"" == "on"){
				quickEditOptions = quickEditOptions + "&qe_optn_DisplayAsTable=true"
			} else quickEditOptions = quickEditOptions + "&qe_optn_DisplayAsTable="+ this.displayAsTable_Value.get('checked');	
			
			return quickEditOptions;			
		},
		  
		destroy: function () {
			if(this.displayAsTable_Value){
				if(this.displayAsTable_Value.destroyRecursive) this.displayAsTable_Value.destroyRecursive();
				else if (this.displayAsTable_Value.destroy) this.displayAsTable_Value.destroy();
			}			
			this.inherited(arguments);		
		}		
	});
});
