// wrapped by build app
define("ibm/tivoli/tip/dijit/themes/ChartThemeTivoliBlack", ["dijit","dojo","dojox","dojo/require!dojox/charting/Theme"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("ibm.tivoli.tip.dijit.themes.ChartThemeTivoliBlack");

dojo.require("dojox.charting.Theme");

(function(){
	ibm.tivoli.tip.dijit.themes.ChartThemeTivoliBlackCustom = { 
		piestroke: {
			color: "white"
		},
		xlabels: {
			color: "white",
			fontFamily: "Sans Serif",
			size: "12pt", 
			weight: "normal"
		},
		ylabels: {
			color: "white",
			fontFamily: "Sans Serif",
			size: "14pt", 
			weight: "normal"
		},
		legend: {
			textClass: "dojoxLegendTextDark"
		}
	};
	ibm.tivoli.tip.dijit.themes.ChartThemeTivoliBlack = new dojox.charting.Theme({
		chart: {
			fill:      null, 
			stroke:    null,
			pageStyle: null
		},
		plotarea: {
			stroke: null,  
			fill: null
		},
		axis:{ 
			stroke:	{ color: "white", width: 1}, 			
			tick: {	
				color:     "white",
				position:  "center",
				font: "normal normal normal 7pt San Serif",
				fontColor: "white"
			},
			majorTick:{ color:"#BFBFBF", width:1, length:6 },
			minorTick:{ color:"#BFBFBF", width:1, length:3 }
		},
		series: {
			stroke: {width: 3, color: "white"}, 
			outline: null, 
			fill: "white", 				
			font: "normal normal normal 8pt San Serif",
			fontColor: "white"
		},
		marker: { 
			stroke:  {width: 0, color: "white"}, 
			outline: {width: 2, color: "white"}, 
			fill: "white", 			
			font: "normal normal normal 8pt San Serif",	
			fontColor: "white"
		},
		colors:[ "#BE99E5", "#FF9D00", "#9BC1FF", "#5FFF3F", "#0000E5", "#E2C6FF", "#FFC259", "#0A74FF", "#FFFF00", "#B9B9E5", "#3C16E5", "#D1E8FF", "#E58F49", "#ffaa1c", "#42B4E5", "#93C9FF", "#E5E52B", "#DBB7FF", "#FFD684", "#53E514"]		
	});	
	
})();

});
