/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
define("ibm/tivoli/tip/navwidget/nls/ar/resources", {      
   "SEARCH_TEXT":"بحث",
   "SAVE_TEXT":"حفظ التهيئات",
   "PRINT_TEXT":"طباعة",
   "SELECT_TEXT":"تحديد",
   "PAN_TEXT":"لوحة",
   "ZOOM_SELECT_TEXT":"تحديد التكبير",
   "ZOOM_IN_TEXT":"تكبير",
   "ZOOM_OUT_TEXT":"تصغير",
   "FIT_CONTENTS_TEXT":"ضبط للمحتويات",
   "REFRESH_TEXT":"تجديد",
   "TOGGLE_LAYOUT_TEXT":"تبديل الشكل العام",
   "TREE_LAYOUT":"التسلسل",
   "HIERARCHICAL_LAYOUT":"مسلسل",
   "FORCE_DIRECTED_LAYOUT":"توجيه الزامى",
   "GRID_LAYOUT":"جدول",
   "SHORT_LINK_LAYOUT":"وصلة قصيرة",
   "LONG_LINK_LAYOUT":"وصلة طويلة",
   "CUSTOM":"تهيئة",
   "SAVE":"حفظ التهيئات",
   "CANCEL":"الغاء",
   "RESTORE_DEFAULTS":"استعادة المفترضات",
   "LAYOUT_MODE":"نمط الشكل العام:",
   "FLOW_DIRECTION":"اتجاه المسار:",
   "LINK_STYLE":"أسلوب الوصلة الشاملة:",
   "CONNECTOR_STYLE":"أسلوب الموصل:",
   "GLOBAL_ALIGNMENT":"المحاذاة الشاملة:",
   "LEVEL_ALIGNMENT":"محاذاة المستوى:",	
   "LEVEL_JUSTIFICATION":"ضبط المستوى:",
   "LEVELING_STRATEGY":"استراتيجية تحديد المستوى:",
   "GLOBAL_HORIZONTAL_ALIGNMENT":"المحاذاة الأفقية الشاملة:",
   "GLOBAL_VERTICAL_ALIGNMENT":"المحاذاة الرأسية الشاملة:",
   "MAX_NUM_NODES_PER_ROW_COLUMN":"الحد الأقصى لعدد العقد لكل صف أو عمود:",
   "PREFERRED_LINKS_LENGTH":"طول الوصلة المفضلة:",
   "LINK_STYLE":"أسلوب الوصلة:",
   "MAX_ALLOWED_MOVE_PER_ITERATION":"الحد الأقصى المسموح به من الحركات لكل تكرار:",
   "ALLOWED_NUMBER_OF_ITERATIONS":"العدد المسموح به من التكرار:",
   "CONVERGENCE_THRESHOLD":"حد التجمع:",
   "GLOBAL_LINK_STYLE":"أسلوب الوصلة الشاملة:",
   "GLOBAL_SELF_LINK_STYLE":"أسلوب الوصلة الذاتية الشاملة:",
   "GLOBAL_CONNECTOR_STYLE":"أسلوب الموصل الشامل:",
   "LINK_OFFSET":"ازاحة الوصلة:",
   "MIN_FINAL_SEGMENT_LENGTH":"الحد الأدنى لطول  المقطع النهائى:",
   "VERTICAL_MIN_OFFSET":"الحد الادنى للازاحة الرأسية:",
   "HORIZONTAL_MIN_OFFSET":"الحد الادنى للازاحة الأفقية:",
   "ASPECT_RATIO":"معدل المظهر:",
   "ALGORITHM":"الطريقة:",
   "GENERAL":"عام",
   "PROPERTIES":"الخصائص",
   "OK":"حسنا",
   "TOPOLOGY_VIEW":"مشاهدة الطوبولوجى",
   "RESOURCE_VIEW":"مشاهدة المصدر",
   "RELATIONSHIP_VIEW":"مشاهدة العلاقة",
   "LINK_VIEW":"مشاهدة الوصلة",
   "GET_ADOBE_FLASH_PLAYER":"أحصل على Adobe Flash player",
   "ADOBE_FLASH_PLAYER_MIN_VERSION":"10.1.0", 
   "ADOBE_FLASH_PLAYER_ENSURE_VERSION":"لمشاهدة هذه المحتويات، تأكد من أن النظام الخاص بك يستوفى متطلبات نظام <a href='${sysReqLink}' target='FLASH_SYS_REQUIREMENTS'></a> ومن تركيب نسخة Adobe&reg; Flash&reg; Player النسخة ${version} أو ما بعدها.", //${sysReqLink} will contain a substituted URL, ${version} will contain substituted product version number (e.g., like 10.1.0) 
   "EMPTY_DATASET":"لا شيء",
   "ITEM_REMOVED_MESSAGE":"تم ازالة هذا البند من فئة البيانات.",
   "LINK_REMOVED_MESSAGE":"تم ازالة هذه الوصلة من فئة البيانات.",
   "RELATIONSHIP_REMOVED_MESSAGE":"تم ازالة هذه العلاقة من فئة البيانات.",
   "ACTIONS":"التصرفات",
   "PRINT_AS_BITMAP":"الطباعة كصورة نقطية:",	   
   "PAGE_COUNT":"عدد الصفحات فى العرض أو الارتفاع:",	 
   "PAGE_COUNT_MAX":"الحد الأقصى للصفحات المطبوعة:",	  
   "PAGE_MARGIN":"هامش الصفحة:",
   "TYPE":"النوع",
   "SOURCEITEM":"من",
   "TARGETITEM":"الى",
   "ITEM1":"البند 1",
   "ITEM2":"البند 2",
   "DATASET1":"فئة البيانات 1",
   "DATASET2":"فئة البيانات 2",
   "LOADING":"تحميل",
   "RESULTS_CLICK_TO_SELECT":"النتائج - اضغط للتحديد",
   "RESULTS":"النتائج",
   "NO_RESULTS_FOUND":"لم يتم ايجاد نتائج",
   "CENTER_IN_VIEW":"توسيط فى المشاهدة",
   "HIGHLIGHT":"اظهار",
   "CLEAR_SEARCH":"محو البحث",
   "DEPTH":"العمق",
   "LAYOUT":"الشكل العام",
   "ACTIONS":"التصرفات",
   "SAVE_CANVAS_CONTEXT":"حفظ التهيئات",
   "SAVE_CUSTOMIZATION_QUESTION":"هل أنت متأكد من أنك تريد حفظ كل التهيئات؟",
   "TOGGLE_VIEW":"تبديل المشاهدة",
   "ALTERNATING_RADIAL":"تبديل نصف القطر",
   "AUTOMATIC":"آلي",
   "BORDER_CENTER":"توسيط الحدود",
   "BOTTOM":"أسفل",
   "CENTER":"توسيط",
   "CENTERED":"فى الوسط",
   "DIRECT":"مباشر",
   "EAST":"باتجاه الشرق",
   "EVENLY_SPACED":"بمسافات متساوية",
   "FAST_MULTILEVEL":"مستويات متعددة سريعة",
   "FIXED_OFFSET":"ازاحة ثابتة",
   "FREE":"حر",
   "HIGHER_LEVELS":"مستويات مرتفعة",
   "INCREMENTAL":"متزايد",
   "LEFT":"باتجاه اليسار",
   "LEVEL":"المستوى",
   "LOWER_LEVELS":"مستويات منخفضة",
   "MIXED":"مختلط",
   "NO_RESHAPE":"لا يوجد اعادة تشكيل",
   "NON_INCREMENTAL":"غير متزايد",
   "NORTH":"باتجاه الشمال",
   "OPTIMAL":"الأمثل",
   "ORTHOGONAL":"متعامد",
   "POLYLINE":"سلسلة خطوط متصلة",
   "RADIAL":"نصف القطر",
   "RIGHT":"اليمين",
   "SEMI_OPTIMAL":"شبه أمثل",
   "SOUTH":"باتجاه الجنوب",
   "SPREAD_OUT":"مبعثر",
   "STRAIGHT":"مستقيم",
   "THREE_BENDS_ORTHOGONAL":"ثلاثة انحناءات متعامدة",
   "TILE_TO_COLUMNS":"تجاور للعمود",
   "TILE_TO_GRID_FIXED_HEIGHT":"تجاور للارتفاع الثابت لخطوط التحديد",
   "TILE_TO_GRID_FIXED_WIDTH":"تجاور للعرض الثابت لخطوط التحديد",
   "TILE_TO_ROWS":"تجاور للصفوف",
   "TIP_LEAVES_OVER":"التسلسل الأخير للنص التوضيحى",
   "TIP_OVER_BOTH_SIDES":"نص توضيحى على كلا الجانبين",
   "TIP_OVER_EAST_WEST":"نص توضيحى على الشرق الغرب",
   "TIP_OVER_WEST":"نص توضيحي على الغرب",
   "TIP_OVER":"نص توضيحي فوق",
   "TIP_ROOTS_AND_LEAVES_OVER":"نص توضيحي على التسلسلات الرئيسية والفرعية",
   "TIP_ROOTS_OVER":"نص توضيحي على التسلسلات الرئيسية",
   "TOP":"أعلى",
   "TWO_BENDS_ORTHOGONAL":"اثنين من الانحناءات المتعامدة",
   "WEST":"غرب",
   "EXPORT":"تصدير",
   "EXPORT_IMAGE_DIALOG_TITLE":"ارسال كصورة",
   "EXPORT_IMAGE_DIALOG_QUESTION":"هل تود ارسال الرسم البيانى كصورة؟ يرجى تحديد النسق المرغوب بالأسفل.",
   "EXPORT_IMAGE_PNG_OPTION_LABEL":"${fileExtension}", //${fileExtension} will contain a file extension like PNG or JPG; creating a specific string with substitution in case we ever want to add more text to the radio button label
   "EXPORT_IMAGE_JPG_OPTION_LABEL":"${fileExtension}", //${fileExtension} will contain a file extension like PNG or JPG; creating a specific string with substitution in case we ever want to add more text to the radio button label
   "ADVANCED_SEARCH":"البحث المتقدم",
   "RESOURCES_COUNT": "المصادر: ${value2}", //$${value2} will contain a substituted number of items in a topology graph 
   "RELATIONSHIP_COUNT": "العلاقات: ${value3}", //${value3} will contain a substituted number of relationships in a topology graph
   "FILTERED_COUNT": "تم ترشيح: ${value4}", //${value4} will contain a substituted number of items in a filtered topology graph
   "SELECTED_COUNT": "تم تحديد: ${value1}", //${value4} will contain a substituted number of selected items in a topology graph
   "ALL":"كل",
   "PARENTHETICAL_ENTRY":"${label} (${parens})", //This is used to create labels followed by additional information in parentheses (e.g., "XXXX (YYYY)", "Demo Group (12)", "sys1 (Topology)", etc.)
   "CUSTOMIZE_LAYOUT":"تهيئة الشكل العام: ${value5}", //${value5} will contain a substituted name of the layout, (e.g., "Customize layout: UserTree_1") 
   "ERROR":"خطأ",
   "PENDING":"فى الانتظار",
   "CLOSE":"اغلاق"
});

