/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
define("ibm/tivoli/tip/navwidget/nls/hr/resources", {      
   "SEARCH_TEXT":"Traži",
   "SAVE_TEXT":"Spremi prilagodbe",
   "PRINT_TEXT":"Ispis",
   "SELECT_TEXT":"Izbor",
   "PAN_TEXT":"Nagib",
   "ZOOM_SELECT_TEXT":"Povećaj odabrano",
   "ZOOM_IN_TEXT":"Povećaj",
   "ZOOM_OUT_TEXT":"Smanji",
   "FIT_CONTENTS_TEXT":"Obuhvati sadržaj",
   "REFRESH_TEXT":"Osvježi",
   "TOGGLE_LAYOUT_TEXT":"Promjena izgleda",
   "TREE_LAYOUT":"Stablo",
   "HIERARCHICAL_LAYOUT":"Hijerarhija",
   "FORCE_DIRECTED_LAYOUT":"Prisilno usmjerenje",
   "GRID_LAYOUT":"Mreža",
   "SHORT_LINK_LAYOUT":"Kratka veza",
   "LONG_LINK_LAYOUT":"Dugačka veza",
   "CUSTOM":"Prilagođeno",
   "SAVE":"Spremi prilagodbe",
   "CANCEL":"Opoziv",
   "RESTORE_DEFAULTS":"Vrati defaultne postavke",
   "LAYOUT_MODE":"Način izgleda:",
   "FLOW_DIRECTION":"Smjer toka:",
   "LINK_STYLE":"Globalni stil veze:",
   "CONNECTOR_STYLE":"Stil konektora:",
   "GLOBAL_ALIGNMENT":"Globalno poravnanje:",
   "LEVEL_ALIGNMENT":"Poravnanje razine:",	
   "LEVEL_JUSTIFICATION":"Usklađivanje razine:",
   "LEVELING_STRATEGY":"Strategija poravnanja:",
   "GLOBAL_HORIZONTAL_ALIGNMENT":"Globalno vodoravno poravnanje:",
   "GLOBAL_VERTICAL_ALIGNMENT":"Globalno okomito poravnanje:",
   "MAX_NUM_NODES_PER_ROW_COLUMN":"Maksimalan broj čvorova po redu ili stupcu:",
   "PREFERRED_LINKS_LENGTH":"Preferirana duljina veza:",
   "LINK_STYLE":"Stil veza:",
   "MAX_ALLOWED_MOVE_PER_ITERATION":"Maksimalno dozvoljenih premještanja po iteraciji:",
   "ALLOWED_NUMBER_OF_ITERATIONS":"Dozvoljen broj iteracija:",
   "CONVERGENCE_THRESHOLD":"Prag konvergencije:",
   "GLOBAL_LINK_STYLE":"Globalni stil veze:",
   "GLOBAL_SELF_LINK_STYLE":"Globalni stil vlastite veze:",
   "GLOBAL_CONNECTOR_STYLE":"Globalni stil konektora:",
   "LINK_OFFSET":"Pomak veze:",
   "MIN_FINAL_SEGMENT_LENGTH":"Minimalna duljina posljednjeg segmenta:",
   "VERTICAL_MIN_OFFSET":"Minimalan okomiti pomak:",
   "HORIZONTAL_MIN_OFFSET":"Minimalan vodoravni pomak:",
   "ASPECT_RATIO":"Omjer slike:",
   "ALGORITHM":"Algoritam:",
   "GENERAL":"Općenito",
   "PROPERTIES":"Svojstva",
   "OK":"OK",
   "TOPOLOGY_VIEW":"Pregled topologije",
   "RESOURCE_VIEW":"Pregled resursa",
   "RELATIONSHIP_VIEW":"Pregled odnosa",
   "LINK_VIEW":"Pregled veza",
   "GET_ADOBE_FLASH_PLAYER":"Preuzmite Adobe Flash player",
   "ADOBE_FLASH_PLAYER_MIN_VERSION":"10.1.0", 
   "ADOBE_FLASH_PLAYER_ENSURE_VERSION":"Za pregled ovog sadržaja vaš sistem mora ispunjavati <a href='${sysReqLink}' target='FLASH_SYS_REQUIREMENTS'>sistemske zahtjeve</a> i mora biti instaliran Adobe&reg; Flash&reg; Player verzije ${version} ili novije verzije.", //${sysReqLink} will contain a substituted URL, ${version} will contain substituted product version number (e.g., like 10.1.0) 
   "EMPTY_DATASET":"Ništa",
   "ITEM_REMOVED_MESSAGE":"Ova stavka je uklonjena iz dataseta.",
   "LINK_REMOVED_MESSAGE":"Ova veza je uklonjena iz dataseta.",
   "RELATIONSHIP_REMOVED_MESSAGE":"Ovaj odnos je uklonjen iz dataseta.",
   "ACTIONS":"Akcije",
   "PRINT_AS_BITMAP":"Ispiši kao bitmap:",	   
   "PAGE_COUNT":"Broj stranica u širinu ili visinu:",	 
   "PAGE_COUNT_MAX":"Maksimalan broj ispisanih stranica:",	  
   "PAGE_MARGIN":"Margina stranice:",
   "TYPE":"Tip",
   "SOURCEITEM":"Od",
   "TARGETITEM":"Do",
   "ITEM1":"Stavka 1",
   "ITEM2":"Stavka 2",
   "DATASET1":"Dataset 1",
   "DATASET2":"Dataset 2",
   "LOADING":"Učitavanje",
   "RESULTS_CLICK_TO_SELECT":"Rezultati - kliknite za odabir",
   "RESULTS":"Rezultati",
   "NO_RESULTS_FOUND":"Nisu pronađeni rezultati",
   "CENTER_IN_VIEW":"Centriraj u pregledu",
   "HIGHLIGHT":"Istakni",
   "CLEAR_SEARCH":"Obriši pretraživanje",
   "DEPTH":"Dubina",
   "LAYOUT":"Izgled",
   "ACTIONS":"Akcije",
   "SAVE_CANVAS_CONTEXT":"Spremi prilagodbe",
   "SAVE_CUSTOMIZATION_QUESTION":"Jeste li sigurni da želite spremiti sve prilagodbe?",
   "TOGGLE_VIEW":"Promjena pregleda",
   "ALTERNATING_RADIAL":"izmjenično radijalno",
   "AUTOMATIC":"automatski",
   "BORDER_CENTER":"centriraj granicu",
   "BOTTOM":"dno",
   "CENTER":"sredina",
   "CENTERED":"centrirano",
   "DIRECT":"usmjeri",
   "EAST":"istok",
   "EVENLY_SPACED":"jednaki razmaci",
   "FAST_MULTILEVEL":"brze višestruke razine",
   "FIXED_OFFSET":"fiksni pomak",
   "FREE":"slobodno",
   "HIGHER_LEVELS":"više razine",
   "INCREMENTAL":"povećavajuće",
   "LEFT":"lijevo",
   "LEVEL":"razina",
   "LOWER_LEVELS":"niže razine",
   "MIXED":"mješovito",
   "NO_RESHAPE":"bez preoblikovanja",
   "NON_INCREMENTAL":"bez povećavanja",
   "NORTH":"sjever",
   "OPTIMAL":"optimalno",
   "ORTHOGONAL":"ortogonalno",
   "POLYLINE":"polilinija",
   "RADIAL":"radijalno",
   "RIGHT":"desno",
   "SEMI_OPTIMAL":"suboptimalno",
   "SOUTH":"jug",
   "SPREAD_OUT":"rašireno",
   "STRAIGHT":"ravno",
   "THREE_BENDS_ORTHOGONAL":"tri ortogonalna luka",
   "TILE_TO_COLUMNS":"slaganje u stupce",
   "TILE_TO_GRID_FIXED_HEIGHT":"slaganje u mrežu fiksne visine",
   "TILE_TO_GRID_FIXED_WIDTH":"slaganje u mrežu fiksne širine",
   "TILE_TO_ROWS":"slaganje u redove",
   "TIP_LEAVES_OVER":"preokretanje listova",
   "TIP_OVER_BOTH_SIDES":"preokretanje strana",
   "TIP_OVER_EAST_WEST":"preokretanje istok zapad",
   "TIP_OVER_WEST":"preokretanje zapad",
   "TIP_OVER":"preokretanje",
   "TIP_ROOTS_AND_LEAVES_OVER":"preokretanje korijena i listova",
   "TIP_ROOTS_OVER":"preokretanje korijena",
   "TOP":"vrh",
   "TWO_BENDS_ORTHOGONAL":"dva ortogonalna luka",
   "WEST":"zapad",
   "EXPORT":"Eksportiraj",
   "EXPORT_IMAGE_DIALOG_TITLE":"Eksportiraj kao sliku",
   "EXPORT_IMAGE_DIALOG_QUESTION":"Želite li eksportirati dijagram u obliku slike? Molimo vas da ispod odaberete željeni format.",
   "EXPORT_IMAGE_PNG_OPTION_LABEL":"${fileExtension}", //${fileExtension} will contain a file extension like PNG or JPG; creating a specific string with substitution in case we ever want to add more text to the radio button label
   "EXPORT_IMAGE_JPG_OPTION_LABEL":"${fileExtension}", //${fileExtension} will contain a file extension like PNG or JPG; creating a specific string with substitution in case we ever want to add more text to the radio button label
   "ADVANCED_SEARCH":"Napredno pretraživanje",
   "RESOURCES_COUNT": "Resursi: ${value2}", //$${value2} will contain a substituted number of items in a topology graph 
   "RELATIONSHIP_COUNT": "Odnosi: ${value3}", //${value3} will contain a substituted number of relationships in a topology graph
   "FILTERED_COUNT": "Filtrirano: ${value4}", //${value4} will contain a substituted number of items in a filtered topology graph
   "SELECTED_COUNT": "Odabrano: ${value1}", //${value4} will contain a substituted number of selected items in a topology graph
   "ALL":"Sve",
   "PARENTHETICAL_ENTRY":"${label} (${parens})", //This is used to create labels followed by additional information in parentheses (e.g., "XXXX (YYYY)", "Demo Group (12)", "sys1 (Topology)", etc.)
   "CUSTOMIZE_LAYOUT":"Prilagodba izgleda: ${value5}", //${value5} will contain a substituted name of the layout, (e.g., "Customize layout: UserTree_1") 
   "ERROR":"Greška",
   "PENDING":"U tijeku",
   "CLOSE":"Zatvori"
});

