/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/dashboard/nls/zh-tw/DashbarResources", {
	//Dashbar Resources BEGIN
	
	// dashbar icon labels
	Chassis : "機座",
	HostAndVs : "主機及 VS",
	Network : "網路",
	Storage : "儲存體",
	Favorites : "我的最愛",
	AllSystems : "所有系統",
	
	// Labels for Tree Toppers Links
	AllVirtualServers : "所有虛擬伺服器",
	AllChasis : "所有機箱",
	AllComputeNodes : "所有計算節點",
	AllStoragePools : "所有儲存區",
	AllStorageNodes : "所有儲存節點",
	AllLogicalNetworks: "所有邏輯網路",
	AllVlans : "所有 VLAN",
	AllSubnets : "所有子網路",
	AllSwitches : "所有交換器",
	LogicalNetworks: "邏輯網路",
	Vlans : "VLAN",
	Subnets : "子網路",
	Switches : "交換器",
	
	// Descriptions of dashbar icons
	ChassisDescription : "包含機箱",
	HostAndVsDescription : "包含虛擬伺服器與主機",	
	NetworkDescription : "包含所有網路系統",	
	StorageDescription : "包含所有儲存體系統",	
	FavoritesDescription : "包含我的最愛項目",	
	AllSystemsDescription : "包含所有可以管理的系統（包括伺服器、機座、作業系統、交換器、刀鋒伺服器及儲存體系統）",	
	
	// Group Health Tips
	RecentEvents : "最新事件：",
	NoRecentEvents : "沒有最新事件",
	RecentAlerts : "最新警示：",
	NoRecentAlerts : "沒有最新警示",
	Source : "來源",
	DateAndTime : "日期與時間",
	Event : "事件",
	
	// General Dashbar
	ResourceDashboard : "資源儀表板",
	Loading : "載入中..."
	//Dashboard Resources end
});

