/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/eventlog/nls/EventLogResources", {
    root: {
	//Event Log Resources BEGIN
	preloadResource : "All Systems",
	preloadView : "Event Log",
	eventFilterHelp : "Select an event filter to display a specific set of events.",
	eventLogPrefsHelp : "Select Event Log Preferences to customize how many events to display.",
	eventLogPrefsCurrentPart1 : "Viewing a maximum of ",
	eventLogPrefsCurrentPart2 : " events from the last ",
	eventLogPrefs : "Event Log Preferences",
	refreshButton : "Refresh",
	lastUpdated : "Last Updated:",
	eventFilter : "Filter by:"
	//Event Log end
    },

    "de": true,
    "zh-tw": true,
    "ko": true,
    "ja": true,
    "en": true,
    "it": true,
    "pt-br": true,
    "fr": true,
    "zh-cn": true,
    "es": true
});