/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012, 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */

define("ibm/usmi/widgets/nls/ja/LoginWindow", {
    "USER_NAME": "ユーザー名",
    "PASSWORD": "パスワード",
    "INVALID_MSG": "入力が無効です。",
	"INVALID_MSG_USR": "指定されたユーザー名が無効です。",
	"INVALID_MSG_PWD": "指定されたパスワードが無効です。",
    "OK": "ログイン",
    "TITLE": "IBM Flex System Manager&trade;",
    "VERSION": "バージョン 1.2.0",
	"BRANDED_VERSION": "バージョン",	// Translators, the actual version number is appended to this string -- so, "Version 6.3.3"
    "COPYRIGHT": "Copyright 2009, 2013 IBM Corporation.",
    "TRADEMARK": "商標",
    "ERROR": "エラー",
    "INVALID": "ユーザー名またはパスワードが無効です。",
    "OLDPASSWORD": "現行パスワード",
    "NEWPASSWORD": "新規パスワード",
    "REPEATPASSWORD": "新規パスワードの確認",
    "DONE": "完了",
    "CHANGEPASSWORD": "パスワードの有効期限が切れました。両方のフィールドに新しいパスワードを入力してパスワードを変更してください。パスワードの規則について情報が必要な場合は、システム管理者に連絡してください。",
    "CHANGEPASSWORDDONE": "パスワードは正常に変更されました。この新規パスワードでログインを再試行してください。",
    "UNKNOWN": "不明",
    "CANCEL": "キャンセル"
});

