define("idx/oneui/gridx/tests/support/modules", [
	'idx/gridx/core/model/extensions/FormatSort',
	'idx/gridx/modules/Focus',
	'idx/gridx/modules/VScroller',
	'idx/gridx/modules/ColumnResizer',
	'idx/gridx/modules/VirtualVScroller',
	'idx/gridx/modules/SingleSort',
	'idx/gridx/modules/NestedSort',
	'idx/oneui/gridx/modules/Sort',
	'idx/gridx/modules/ColumnLock',
	'idx/gridx/modules/select/Row',
	'idx/gridx/modules/select/Column',
	'idx/gridx/modules/select/Cell',
	'idx/gridx/modules/extendedSelect/Row',
	'idx/gridx/modules/extendedSelect/Column',
	'idx/gridx/modules/extendedSelect/Cell',
	'idx/gridx/modules/move/Row',
	'idx/gridx/modules/move/Column',
	'idx/oneui/gridx/modules/dnd/Row',
	'idx/oneui/gridx/modules/dnd/Column',
	'idx/gridx/modules/AutoScroll',
	'idx/gridx/modules/pagination/Pagination',
	'idx/gridx/modules/pagination/PaginationBar',
	'idx/gridx/modules/pagination/PaginationBarDD',
	'idx/gridx/modules/filter/Filter',
	'idx/gridx/modules/filter/FilterBar',
	'idx/gridx/modules/CellWidget',
	'idx/gridx/modules/Edit',
	'idx/gridx/modules/RowHeader',
	'idx/gridx/modules/IndirectSelect',
	'idx/gridx/modules/Persist',
	'idx/gridx/modules/exporter/Exporter',
	'idx/gridx/modules/exporter/CSV',
	'idx/gridx/modules/exporter/Table',
	'idx/gridx/modules/Printer',
	'idx/gridx/modules/Menu',
	'idx/gridx/modules/Dod',
	'idx/gridx/modules/SummaryBar',
	'idx/gridx/modules/ToolBar',
	'idx/gridx/modules/TitleBar',
	'idx/gridx/modules/Tree',
	'idx/gridx/modules/RowLock',
	'idx/oneui/gridx/modules/filter/QuickFilter',
	'idx/oneui/gridx/modules/pagination/PaginationBar'
], function(FormatSort, 
	Focus, VScroller, ColumnResizer, VirtualVScroller,
	SingleSort, NestedSort, Sort, ColumnLock,
	SelectRow, SelectColumn, SelectCell,
	ExtendedSelectRow, ExtendedSelectColumn, ExtendedSelectCell,
	MoveRow, MoveColumn,
	DndRow, DndColumn, AutoScroll,
	Pagination, PaginationBar, 
	PaginationBarDD,
	Filter, FilterBar,
	CellWidget, Edit,
	RowHeader, IndirectSelect,
	Persist, Exporter, CSV, Table, Printer,
	Menu, Dod, 
	SummaryBar,
	ToolBar, TitleBar, Tree, RowLock, QuickFilter,
	OneUIPaginationBar){
return {
	FormatSort: FormatSort,
	Focus: Focus,
	VScroller: VScroller,
	ColumnResizer: ColumnResizer, 
	VirtualVScroller: VirtualVScroller,
	SingleSort: SingleSort,
	NestedSort: NestedSort,
	ColumnLock: ColumnLock,
	SelectRow: SelectRow,
	SelectColumn: SelectColumn,
	SelectCell: SelectCell,
	ExtendedSelectRow: ExtendedSelectRow,
	ExtendedSelectColumn: ExtendedSelectColumn,
	ExtendedSelectCell: ExtendedSelectCell,
	MoveRow: MoveRow,
	MoveColumn: MoveColumn,
	AutoScroll: AutoScroll,
	Pagination: Pagination,
	PaginationBar: PaginationBar,
	PaginationBarDD: PaginationBarDD,
	Filter: Filter,
	FilterBar: FilterBar,
	CellWidget: CellWidget,
	Edit: Edit,
	RowHeader: RowHeader,
	IndirectSelect: IndirectSelect,
	Persist: Persist,
	Exporter: Exporter,
	ExportCSV: CSV,
	ExportTable: Table,
	Printer: Printer,
	Menu: Menu,
	Dod: Dod,
	SummaryBar: SummaryBar,
	ToolBar: ToolBar,
	TitleBar: TitleBar,
	Tree: Tree,
	RowLock: RowLock,

	//OneUI specific
	DndRow: DndRow,
	DndColumn: DndColumn,
	Sort: Sort,
	QuickFilter: QuickFilter,
	OneUIPaginationBar: OneUIPaginationBar
};
});
